--------------------------------------------------------------------------------
(1) → Expand RBT.action() until we have listed ALL actions there.
      Evaluate at some point in the future when this will be
      achieved.
      ^^^ continue here. All bin/ files are now executable, since as
      of September 2022. But we probably should add even more
      actions here, in particular several troublemaking
      steps within RBT::Compile.
      Then also look at menu.rb of class RBT::Compile to see which
      individual tasks can be made "actionable" still.
      Once that is all done, perhaps in 2023 or so,
      remove this todo entry here.
      Ok, bin/ is now complete, we must go through menu() still
      and see.
      ^^^ we are doing this RIGHT NOW.
--------------------------------------------------------------------------------
(2) → Handle these commandline instructions, which originated from the old
      class RBT::Commandline but are not yet completely ported:
# rbt --download=htop # <- implemented \o/
# rbt --set-source-dir=/Files/Archive/
#
# rbt --download htop
# ^^^ all the above cases work now.
      rbt --download glibc-2.28
      rbt --download-into-proper-directory htop
      rbt --download-proper htop
      rbt --download-into-dir htop
      rbt pin htop
      rbt --set-source-dir /Files/Archive/
      opnn; RBT.permanently_set_source_directory($3.to_s.dup) { :be_verbose }
      ^^^
--------------------------------------------------------------------------------
(3) → Continue porting old RBT code to the new infrastructure.
--------------------------------------------------------------------------------
(4) → enable in rbt a way to download a remote package
      that has ... well binutils and so forth
      from which we can then bootstrap the compile
      environment, in the event that some error happens
--------------------------------------------------------------------------------
(5) → one day add a meta-action:
      :build_lfs_from_scratch
      AND
      :build_blfs_from_scratch
      This shall create all necessary steps.
      We already describe some of the steps, but not all.
--------------------------------------------------------------------------------
(6) → 1)
      we may have to rewrite infer the build systrem.
      perhaps split it up.
      One part should ONLY be used to determine the build
      system from a DIRECTORY.
      Also name it appropriately, say:
      class InferTheBuildSystemFromThisDirectory
      end
      and the other class shall do ... whatever the old one did.
      THIS IS FOR THE BUILD SYSTEM
# ========================================================================= #
# === infer_the_build_system
#
# This method will return a String, indicating which build system is
# most likely to be used for a given program at hand.
# ========================================================================= #
      def infer_the_build_system(
      i             = :infer_automatically,
      program_path  = nil,
      depends_on    = nil, # ← This optional argument can be an Array.
      optional_hash = {}
      )
      use_a_build_directory = false
      unless optional_hash.empty?
# ===================================================================== #
# === :use_a_build_directory
# ===================================================================== #
      if optional_hash.has_key? :use_a_build_directory
      if optional_hash[:use_a_build_directory] == true
      use_a_build_directory = true
      end
      end
      end
      case i
# ======================================================================= #
# === :infer_automatically
#
# Must query whether we will try to infer the build system automatically.
# ======================================================================= #
      when :infer_automatically,
      :default,
      nil
      set_use_this_build_system nil # ← Default start value.
      iterate_over_the_build_system_priorities
      end
      return @use_this_build_system # Return our findings here.
      end; alias infer_build_system infer_the_build_system # === infer_build_system
      if @use_this_build_system.nil?
# ===================================================================== #
# If it is still nil then we try some other checks.
# ===================================================================== #
# ===================================================================== #
# === Check for a rubygem file:
# ===================================================================== #
      elsif program_path and program_path.end_with?('.gem')
      set_use_this_build_system 'rubygem'
# ===================================================================== #
# === Check for ninja:
# ===================================================================== #
      elsif depends_on and depends_on_ninja?(depends_on)
      set_use_this_build_system 'ninja'
      else
      if i.is_a? Symbol
      e "#{rev}Unregistered symbol: #{i}"
      else
      set_use_this_build_system i
      end
      end
      end
      if does_this_file_exist?("#{i}configure") and
      configure_has_a_higher_priority_than_meson?
      set_use_this_build_system 'configure'
      end
# ========================================================================= #
# === iterate_over_the_build_system_priorities
# ========================================================================= #
      def iterate_over_the_build_system_priorities
# ======================================================================= #
# We will simply iterate over the Array that originated from the
# file 'build_systems_priorities.yml'.
# ======================================================================= #
      dataset_from_build_systems_priorities?.each {|this_entry|
# ===================================================================== #
# We will only modify the above variable if it is nil, since that
# means it has not yet been specified in more detail.
# ===================================================================== #
      if @use_this_build_system.nil?
      case this_entry
# ================================================================= #
# === cmake
# ================================================================= #
      when 'cmake'
# =============================================================== #
# === Handle cmake installation types next
#
# This ought to come quite early.
# =============================================================== #
      if does_this_file_exist?(FILE_CMAKE_LISTS, use_a_build_directory)
      if depends_on and depends_on_cmake?
      set_use_this_build_system 'cmake'
      else
      set_use_this_build_system 'cmake'
      end
      end
# ================================================================= #
# === meson
# ================================================================= #
      when 'meson'
      if meson_build_file_exists?(:default, use_a_build_directory) # In this case, handle meson.
      set_use_this_build_system 'meson'
      end
# ================================================================= #
# === waf
# ================================================================= #
      when 'waf'
# =============================================================== #
# === Handle 'waf' installations next
# =============================================================== #
      if does_this_file_exist?(FILE_WAF, use_a_build_directory) and
      !meson_build_file_exists?
      if depends_on and depends_on_waf?
      set_use_this_build_system 'waf'
      else
      set_use_this_build_system 'waf'
      end
      end
# ================================================================= #
# === scons
# ================================================================= #
      when 'scons'
# =============================================================== #
# === Handle programs based on scons next
# =============================================================== #
      if does_this_file_exist?(FILE_SCONS) and
      !meson_build_file_exists?
      if depends_on and depends_on_python?
      set_use_this_build_system 'scons'
      else
      set_use_this_build_system 'scons'
      end
      end
      end
      end
      }
      end
# =========================================================================== #
# === RBT.infer_build_system
# =========================================================================== #
##def self.infer_build_system(
#   i = ARGV,
#   &block
# )
      _ = RBT::Action::InferBuildSystem.new(i, &block)
# return _.build_system?
#nd
--------------------------------------------------------------------------------
(7) → validate_all_cookbook_entries
      ^^^ continue there and add homepages to every entry.
      ^^^^^^ being handled right now.
      YES LET'S HAVE HOMEPAGE ENTRIES !!!!
      Every program should have one.
--------------------------------------------------------------------------------
(8) → rewrite it again? hmmmmmm...
      Fix this bug:
      1) ry M4 ntrad --use-this-as-program-name=M62
      homepage tag has to be added still
      ^^^ and add homepage tags... this is simple
--------------------------------------------------------------------------------
(9) → incorporate build systems priorities yml file,
      but we need to test it on some program
      perhaps gnome program
      and also make it possible to query that via the
      ruby-gtk wrapper. aka "infer build system"
      from this path or something like that.
--------------------------------------------------------------------------------
(10) → Rewriting RBT (Rewriting RBT once again!):
      1a) → if we rewrite rbt then start with the "does the file
      exist locally". If yes, go through it.
      Well this needs a bit more planning...
      AND when it works, document it.
      ^^^^^
      1b) → during the rewrite we must enable --expand to read from the
      expanded dataset too, rather than loading the original yaml
      file and sanitizing it. The user must be able to decide
      on his or her own here.
      ^^^
      1c) → if we rewrite RBT then perhaps we should first
      write the logic into a standalone file,
      which then gets loaded and parsed.
      This all needs more planning though. we will do the three
      things or rather two things at a later time ...
      Use some indent way or so:
      Hmmm. If we have a separate logic-file:
      Just describe things in a general way. And handle these sub-tasks
      individually.
      - extract_archive
      - compile_or_install # For packages too.
      - compile_step (cmake, configure etc..)
      extract archive
      if file exists
      else
      and perhaps also start with a test case or so.
--------------------------------------------------------------------------------
(11) → Write SIMPLE ruby-gtk bindings STANDALONE.
      ^ Nur die core functionality.
      ^^^ das dann inkludieren.
      Display RBT Version here.
      ______________________________________________________________________
      [ display available programs here] |
      via drop down listing         |
      | INPUT FIELD ___
      | ^^^compile this program
      |   button [start compiling]
      RESULT MESSAGES WILL SHOW UP HERE.
      alias gtk_compile
      SYSTEM/compile_program.rb:
--------------------------------------------------------------------------------
(12) → Ensure that scons-related compiling can work:
# ========================================================================= #
# === compile_via_scons                                         (scons tag)
#
# We compile via Scons, by making use of class Scons.
# Please ensure that the given prefix is correct before passing it to
# this method. It will set a new prefix to our scons string.
# ========================================================================= #
      def invoke_scons_compiling(prefix = '/usr')
      e 'The prefix for RScons will be: '+prefix
      @rscons.set_prefix prefix
      @rscons.run
--------------------------------------------------------------------------------
(13) → Ensure that we can obtain a random program:
      rbt --random?
      rbt random?
      rbt RANDOM?
      rbt RANDOM
      rbt rand # ^^^ test these
      AND also make sure that this works:
      case entry
      when *ARRAY_HELP_LAST_COMPILED_PROGRAM_OPTIONS
      entry = last_compiled_program?
      end
      e.g:
      rbt --last-compiled-program?
--------------------------------------------------------------------------------
(14) → Work on RBT in such a way that it will make it super-easy to
      setup a new system from scratch on my gobolinux laptop.
      In order to do this, start the gobolinux laptop again
      hmmm.
      Or perhaps downstairs. Or the other laptop? Or buy a new
      laptop? Choices, choices. Well - laptop is simpler IMO.
      ^^^ yeah use gobolinux on the laptop again!
--------------------------------------------------------------------------------
(15) → START of the OLD CONGLOMERATE, such as via old_installer.rb:
      def compile(this_program, real_name = database_loader.short_name)
# ======================================================================= #
# Next we check if we have to compile or not. If not, we skip in the
# next section.
# ======================================================================= #
      if CONFIG.check_if_compiling_is_in_progress == true && File.exist?('COMPILING_IS_IN_PROGRESS')
      run_postinstall_actions
      opn; warn 'Compiling seems to be already in progress.'
      opn; warn "Won't continue because of this."
      opn; warn_then_exit '(Remove the file COMPILING_IS_IN_PROGRESS or
      the archive in question if you still want to continue)'
      else
      if CONFIG.check_if_compiling_is_in_progress
      append 'Compiling program '+database_loader.program_name?, 'COMPILING_IS_IN_PROGRESS'
      end
# ======================================================================= #
# We must decide:
#   The checks are important here: We dont want a general "else" case
#   because all checks should be handled, "else" is simply not a legit
#   option here. A user should be able to fine tune it to his/her needs
#   too. We need to be totally sure *how* to install something, thus
#   these if/else [conditional] checks must be used instead of a general
#   else [no_conditional].
# ======================================================================= #
# TRADITIONAL WAY (FHS Way)
# ======================================================================= #
      if database_loader.prefix == true
      compile_how(:traditional)
# ======================================================================= #
# Compile without giving any prefix.
# ======================================================================= #
      elsif database_loader.prefix == 'none'
      compile_how(:undefined)
# ======================================================================= #
# And now, really the last step here is to return whether compilation
# was a success or a failure. This return value can be used by other
# programs. (Can be true or false) We will not do so when we only
# install headers though.
# ======================================================================= #
# ========================================================================= #
# === save_yaml_file_last_compiled_configure_options
# As input, pass the configure options to this method.
# ========================================================================= #
      def save_yaml_file_last_compiled_configure_options(i)
      _ = CONFIG.store_into_this_directory+'YAML/last_compiled_configure_options.yml'
      create_directory_at_base_of(_) # If it does not exist.
      if @run_simulation
      opn; ci 'We are running in simulation mode, hence we will not '
      opn; cif 'store into '; cfile _
      else
      if File.writable?(File.dirname(_)) # We need to get the directory name.
      opn; ci 'Storing `'+i+'` into '; f '   '+_
      save_yaml(_, i)
      else
      opn; warnf 'Can not write into file '; cfile _
      opn; warn 'because of insufficient permissions.'
      end
      end
      end
# ========================================================================= #
# === save_yaml_file_last_compiled_program
#
# Store the dataset into a yaml file.
# ========================================================================= #
      def save_yaml_file_last_compiled_program(i)
      _ = LAST_COMPILED_PROGRAM_LOCATION
      create_directory_at_base_of(_) # If it does not exist.
      if @run_simulation
      opn; ci 'We are running in simulation mode, hence we will not '
      opn; cif 'store into '; cfile _
      else
      if File.writable?(File.dirname(_)) # We need to get the directory name.
      opn; ci 'Storing `'+i.downcase+'` into '; f '   '+_
      save_yaml(_, i.downcase)
      else
      opn; warnf 'Can not write into file '; cfile _
      opn; warn 'because of insufficient permissions.'
      end
      end
# ========================================================================= #
# === prepare_program
# ========================================================================= #
      def prepare_program(which_program = @program_to_compile)
# Intercept for help.
# ========================================================================= #
# === compile_all_versions
#
# This is used to compile all versions and apply the same logic
# to all of them when doing so.
# ========================================================================= #
      def compile_all_versions(i)
      cfav = CheckForAvailableVersions.new(i)
      cfav.check_for_program(:be_silent)
      _ = cfav.available_versions
      opne 'We apply a common operation on these programs now:'
      e '  '+_.join(', ').wrap_at()
      chained = Chained.new(_)
      chained.start_compiling
# _.each do |v|
# pp v
# compile(v)
      end
# ======================================================================= #
# Also set an easier handle to it → @sanitized_program_entry
# ======================================================================= #
      @sanitized_program_entry = sanitized_data
      @do_not_symlink = @sanitized_program_entry.do_not_symlink?
# ======================================================================= #
# Find out whether we have included the program or not here. This is a
# critical and important decision.
# ======================================================================= #
      _ = @query.program_was_found?
      cliner {
      opne 'Installer.rb: Line '+__LINE__.to_s+', was the program `'+
      @program_to_compile+'` found? '+vt(_)
      } if @debug
      if _
      _ = @query.database_loader
      @skip_extracting = true if _._.archive_type == '.exe' # leave .exe files alone
# ===================================================================== #
# From that point on, we use the stored data of
# _.configure_command, assigned to our ConfigureString object
# ===================================================================== #
      @object_configure_string.set_string(_._.use_this_configure_command)
# stores dependencies
      @dependency_collector = DependencyCollector.new(@program_to_compile, @query)
# Now we assume a few things:
      dependencies = _.sanitized_data.required_deps_on
      extra_information = _.sanitized_data.make_options
      determine_build_type(dependencies, extra_information)
      general_sanitize_method
      else # else exit cuz we did not find what we sought.
      exit_program if @exit_program
      end
      end
# ========================================================================= #
# If this is set to a path, we extract to this dir, which can be useful
# for packages or fluxbox styles. Also, here we handle extraction of the
# source files including chdir to the newly created directory. This is done
# via class bl $RBT/RExtracter.rb
# ========================================================================= #
      def consider_extracting_program(extract_where_to = database_loader.extract_to.dup)
      if @archive_exists
      unless CONFIG.check_if_compiling_is_in_progress == true and File.exist? _+'/COMPILING_IS_IN_PROGRESS'
      ^^^^ make sure we keep track of this somewhere
      if File.exist? extract_where_to
      change_directory(extract_where_to)
      else
      warn_then_exit 'But dir '+sdir(extract_where_to)+' does not exist!'
      end
      else # this is for i.e. exo, which keeps a sub_dir setting
      this_package = rds(
      database_loader.extract_to+'/'+database_loader.sub_dir+'/'+database_loader.program_full_name)
      @extracter.set_source_location this_package
      _ = rds(database_loader.extract_to+'/'+database_loader.sub_dir)
      unless CONFIG.check_if_compiling_is_in_progress == true and File.exist? _+'/COMPILING_IS_IN_PROGRESS'
      @extracter.extract_to _
      end
      verbose_chdir rds(
      database_loader.extract_to+'/'+database_loader.sub_dir+'/'+database_loader.program_name?
      )
      end
      end
# ========================================================================= #
# === handle_binary_installation
#
# This method is a wrapper towards InstallPackage.rb.
# Usage example:
#   ry koffice binary
#
# This will install the koffice binary.
# How is it doing this task?
# -) Well, we scan through the PKG directory and
#    thus register the content # of installable packages.
# ========================================================================= #
# === create_package
#
# Allows you to dump a package by passing in its type.
#   ry tea slackware
# ========================================================================= #
      def create_package(
      type_of_package = :default,
      for_optional_program_name = nil,
      shall_we_exit = true
      )
      case type_of_package
      when :default # create a default package here.
      shall_we_exit = false
      when :slackware
      change_directory PROGRAMS_DIR
      name = database_loader.shortcut_name?.downcase.my_cap
      change_directory name
      RPackages.create_slackware_package database_loader.program_name?
      opn; cif 'Moving '; cfilef database_loader.program_name?.downcase+'.tgz'
      cif ' to '; cdir '/'
      move_file database_loader.program_name?.downcase+'.tgz', '/'
      remove_dir 'install'
      end
      exit_program if shall_we_exit
# ========================================================================= #
# === create_recipe                                            (recipe tag)
#
# This allows you to create a specific recipe. Also note that, in case we
# create .yml files, we will try to sanitize the information so that the
# yaml file can remain standalone.
#
# To dump ruby recipes, do i.e. this:
#   ry python dumpall
#   ry python rubyrecipe
#   ry python to_bash
# ========================================================================= #
      def create_recipe(
      type_of_recipe = :gobo,
      for_optional_program_name = nil,
      shall_we_exit = true
      )
      case type_of_recipe.to_sym
      when :bash, :batch
      to_bash # batch mode available only.
      when :ruby
      create_ruby_recipe(for_optional_program_name)
      when :gobo, :gobolinux
      create_gobo_recipe(for_optional_program_name)
      when :gentoo, :ebuild
      create_ebuild_recipe(for_optional_program_name)
      when :default, :normal, :standalone # the default
      create_simple_recipe(for_optional_program_name)
      end
      exit_program if shall_we_exit # On default, we exit. Pass false
# as 3rd argument to not exit (which is useful for batch-mode install)
# ========================================================================= #
# === create_simple_recipe
#
# This will create a standalone recipe. To invoke this, do something
# like:
#   ry php simple
# Or to dumpall:
#   ry php dumpall
# ========================================================================= #
      def create_simple_recipe(this_program)
      seek_program(this_program)
      create_recipe = CreateRecipe.new(this_program, @sanitized_program_entry, false)
      create_recipe.run
# ========================================================================= #
# === upload_recipe_to
# This can be used to upload a specific recipe to a place.
# Perhaps this should be generalized later, so that we can upload
# anything with it, but for now, I need it only for recipes.
# Usage example:
#   ry php upload /tmp/python-3.1.1.recipe
# ========================================================================= #
      def upload_recipe_to(this_recipe, this_url = 'ftp.members.a1.net')
      ftp_object = StdFtp::FTP_Lib.new
      ftp_object.build_ftp_object
      ftp_object.change_directory 'html'
      ftp_object.upload(this_recipe)
      e ENV['UNIWWW']+File.basename(this_recipe)
# ========================================================================= #
# === create_ruby_recipe
# Do you want to create pure Ruby Recipes?
# Then this method allows you to drop a .rb file, which
# self_contains all the info needed to compile a specific
# program (or to simply extract it, if its a binary file.)
#
# These recipes will be stored here:
#   cd /System/Recipes/
#
# Usage example:
#   ry file toruby
#
# THIS METHOD IS NOT NOT YET compeltey FINISHED but soon there!!!
# ========================================================================= #
      def create_ruby_recipe(for_this_program = '')
      this_file = CONFIG.recipes_dir+for_this_program+'.rb'
      puts
      cliner {
      opn; ff 'Now creating recipe for '; cfilef for_this_program
      ff ' in '; cfile this_file
      }
      puts
# bl $RBT/RPackageSkeleton.rb
      this_string = "require 'rbt/RPackageSkeleton.rb'"+N+N
      this_string << 'class '+database_loader.short_name.my_cap+' < '+'RPackageSkeleton'+N+N
      this_string << '  def initialize'+N+N
      this_string << '    super({'+N
      this_string << '      :description => \''+database_loader.description?.chomp+'\','+N
      deps_on = database_loader.required_deps_on?
      this_string << '      :required_deps_on => "'+deps_on+'",'+N if deps_on
      this_string << '      :homepage => "'+database_loader.last_url?+'",'+N
      this_string << '      :base_dir => "'+database_loader.base_dir?+'",'+N
      this_string << '      :program_name => "'+database_loader.program_name?+'",'+N
      unless database_loader.override?.to_s.empty?
      this_string << '      :override => '+database_loader.override?.to_s+','+N
      end
      this_string << '      :prefix => '+database_loader.prefix?.to_s+','+N
      this_string << '      :file_location => "'+SOURCE_DIR+'/'+database_loader.base_dir+'",'+N
      this_string << '      :recipe_type => :source,'+N
      unless database_loader.make_options.empty?
      this_string << '      :make_options => "'+database_loader.make_options?+'",'+N
      end
      this_string << '    })'+N+N
      this_string << '  end'+N+N
      this_string << 'end'+N+N
      this_string << for_this_program.my_cap+'.new'+N
      append_what_into(this_string, this_file)
      database_loader.feedback_dependencies
      ci 'Finished dumping ruby-recipe for '+for_this_program+'.'
      end
# ========================================================================= #
# === intercept_database_creation
# Intercept our database creation. Here, we check whether we want to add
# a new program to our database, or if we dont want to do that. You can
# retrieve the data from your sqlite3 database again, see the following
# example:
#   select * from installed_programs;
#   wmii|3
#   cairo|1.0.4
#   cairo|1.2.0
# ========================================================================= #
      def intercept_database_creation
      if CONFIG.use_sqlite3_database
# Ask silently. Dont want to spam too much.
      name = @query.real_shortcut_name
      version = program_version?
      description = database_loader.description # beschreibung
      binaries = database_loader.binaries # beschreibung
# Default database
      database_location = CONFIG.sys_info_dir+'/installed_programs.db'
      if    name == 'not found' # Pass through if not found.
      elsif name.empty? # Pass through if empty name
      else
# ========================================================================= #
# === save_compile_time_information
#
# This method stores information about the compile time. It stores:
#  (1) Program Name
#  (2) Program Version
#  (3) date
#  (4) gcc version
#  (5) glibc version
#  (6) architecture
#  (7) configure_options
# ========================================================================= #
      def save_compile_time_information(dir)
      _ = rds(dir+'/CompileTimeInformation')
      remove_file(_) # clean up first.
      append_what_into('Program name: '+@_, _) # 1
      append_what_into('Program version: '+database_loader.program_version, _) # 2
      append_what_into('Compiled at: '+return_date+', Time of the day: '+return_time, _) # 3
      gccv = `gcc -v 2>&1` # The regex in the line below removes all what is between ()
      append_what_into('GCC Version: '+gccv.split(N)[-1].upcase.gsub(/\(.+\)/,''), _) # 4
      glibcv = `ldd --version`
      unless glibcv.empty? # Need to check here because the user may not have ldd installed.
      append_what_into('Glibc Version: '+glibcv.split(N)[0].gsub(/\(.+\)/,''), _) # 5
      end
      append_what_into('Architecture: 64 Bit', _) # 6 - Hack
      append_what_into('Configure options used: '+@object_configure_string.string?.to_s,_) # 7
# ========================================================================= #
# === repackage
#
# This method will repackage a given tarball.
# ========================================================================= #
      def repackage(i)
      _ = Repackage.new(i) # bl $TOOLS/repackage.rb
      _.repackage_data # send stuff to the sys chain.
      end
# ========================================================================= #
# === create_directory_at_base_of
# ========================================================================= #
      def create_directory_at_base_of(i) # If it does not exist.
      dir = File.dirname(i)
      if ! File.exist?(dir)
      create_directory(dir)
      end
      end
# ========================================================================= #
# === gather_all_dependencies
# Invoke this only from the case menu please. Example:
#   ry php fdep
# ========================================================================= #
      def gather_all_dependencies
# first must run it to get the info.
      @dependency_collector.gather_dependencies
      opne 'Getting dependencies next (including itself):'
      pp @dependency_collector.array_compilation_dependencies
      array = @dependency_collector.array_compilation_dependencies
      _ = Chained.new(array)
      _.set_compile_mode
      _.start_compiling
      end
# ========================================================================= #
# === program_version?
# Simplified wrapper towards our data object.
# ========================================================================= #
      def program_version?
      database_loader.program_version?
      end
# ========================================================================= #
# === check_argument                                   CASE TAG (ARGS TAG)
# Decide what to do with the info provided by Query. This is a VERY
# important convenience method. Note also that `this_argument` will be
# the third-or-so argument, but definitely not the first to come.
# This method is called from within compile()
# ========================================================================= #
      def check_argument(this_argument)
      cliner {
      e 'this_argument was '+this_argument.to_s
      } if @debug
# this_argument = this_argument.gsub(/--/,'') # get rid of -- since FEB 2011
      case this_argument
# ======================================================================= #
# We want to compile something with all dependencies
# Usage examples:
#   ry tango-icon all-debs
#   ry fluxbox with-deps
# However something is weird with this method. Is it obsoleted?
# Takes some time to figure out  hmmm...
# I think it is a bit obsolete thus i grayed it out for now.
# I HAVE TO REEVALUATE LATER
# Whjich other method checks for dependencies? I think there is a
# class that does this.
# ======================================================================= #
# ======================================================================= #
# ry php trad?
# ======================================================================= #
      when 'mode','mode?','trad?','prefix?'
      feedback_mode
      exit_program
# ======================================================================= #
# ry htop feedback_urls
# ======================================================================= #
      when 'feedback_urls','feedback_url','feedbackurl','ufeed'
      feedback_urls
      exit_program
# when 'enableshared'
# ======================================================================= #
# Suppress output:
#   ry php suppress-output
# ======================================================================= #
      when 'suppress-output','suppressoutput','sout','soutput','souput',
      'suppress_output','be_silent','besilent'
      opne 'We will use systemu to suppress system output.'
      @use_systemu = true
# ======================================================================= #
# ry yasm ifiles
# ======================================================================= #
      when 'installedfiles','ifiles'
      _ = @_
      unless _.include?('/')
      _ = CONFIG.programs_dir+'/'+@_.capitalize+'/Current'
      end
      save_installed_files_information(_)
      exit_program
# ======================================================================= #
# Generate a new cookbook:
#   ry generate_new
# ======================================================================= #
      when 'generate_new','generate_new_cookbook','generatenewcookbook'
      generate_new_cookbook
      exit_program
# ======================================================================= #
# If the user wants to treat his input as name for a binary, then this
# piece of code here helps him do so. It will try to compile the
# respective program and overrule the alias.
#
# Usage examples:
#   ry ld check_as_binary_name # will fetch binutils.
#   ry ruby cabn
# ======================================================================= #
      when 'check_as_binary_name','as_binary_name','binaryname','bname',
      'asbinaryname','treat_as_library_name','treat_as_binary_name','cabn',
      'as_binary','asbinary'
      opne 'We will check for a binary name.'
      @query.bypass_name_check = true
# ======================================================================= #
# Daemonize the object.
#   ry php5 to_background
# ======================================================================= #
      when 'daemonize','dämon','demon','to_background','background',
      'dae','daem','tobg'
      opn; cii ' => Soon Daemonizing the Accessor Data Object.'
      _ = DistributedInfrastructure.new @program_to_compile
      _.create_yaml_accessor
      _.daemonize
      exit_program # Now that we are daemonized we can exit
# ======================================================================= #
# This will create _multiple_ recipe files (Gobo, ruby and ebuild):
#   ry ruby dumpall
# ======================================================================= #
      when 'dumpall','dall','recipes','allrecipes'
# Create all our recipes.
      cliner { opn; ci ' => Dumping all available recipes next.' }
      all_programs.each { |my_program|
      f "This program is: `#{my_program}`"
      seek_program(my_program)
      create_recipe(:ruby,       my_program, false)
      create_recipe(:gobo,       my_program, false)
      create_recipe(:ebuild,     my_program, false)
      create_recipe(:standalone, my_program, false)
      }
      cliner {
      opn; ciif 'Finished dumping all Recipes into '
      cdir CONFIG.recipes_dir
      f N+'There were: '+all_programs.size.to_s+' of them.'+N
      }
      exit_program
# ======================================================================= #
# This dumps just a single recipe.
#   ry python rubyrecipe
# ======================================================================= #
      when 'recipe','r','drop','dr','dump','dum','rubyrecipe','ruby_recipe',
      'dump_recipe','dumprecipe','toruby','to_ruby','rubyrecipes'
      create_recipe(:ruby, database_loader.program_name?)
# ======================================================================= #
# Create a slackware package.
#   ry gcc slackware
# ======================================================================= #
      when 'slackware','slackw','slack'
      create_package(:slackware)
# ======================================================================= #
# ry php upload /tmp/python-3.1.1.recipe
# ======================================================================= #
      when 'upload','upload_to'
      upload_recipe_to(@array_other_commands[1])
      exit_program
# ======================================================================= #
# Invoke the following as in:
#   ry php fdep
#   ry feh fdep
# ======================================================================= #
      when 'with_dependencies','full_dependencies','full_deps','get_deps',
      'getdeps','gdeps','fdep','withdeps','with-deps','all-deps',
      'alldeps','adeps','includedeps','wdeps','wdep','fdeps',
      'wdependencies','wd'
      gather_all_dependencies
      exit_program
# ======================================================================= #
# Apply a common operation on each member of a specific version:
#   ry glib all_versions
#   ry gtksourceview ntrad all_versions
# ======================================================================= #
      when 'all_versions','allversions','aversions'
      compile_all_versions(@_)
      exit_program
# ======================================================================= #
#
# ======================================================================= #
      when 'global','globa','glob','glo','gl','g','inter'
      opn; cii ' => We look if we find an entry that is interlinked.'
      opn; cii ' => '+database_loader.feedback_chained_programs
      exit_program
# ======================================================================= #
# ry x rall
# ======================================================================= #
      when 'register_all','registerall','rall','allregistered',
      'register_all_programs'
      _ = get_all_programs.sort.map {|x| x << '/Current'}
      _.each { |program| register_this_program(program) }
      exit_program
# ======================================================================= #
# Install a binary package, i.e. via:
#   ry gcc binary
#   ry fox binary
# ======================================================================= #
      when 'binary','binstall','binary install','package',
      'install','inst','i','install_package'
      this_program = database_loader.name+'-paco.tar.bz2'
      opne ' => Trying binary installation of '+
      "#{database_loader.name} next" # cuz the binary name can be different
      handle_binary_installation(this_program)
      when nil,''
# silently pass through when nil or empty.
# ======================================================================= #
# Else tag. We must also handle special instructions given to us here,
# like sleep44 or sleep555 which can be a variable number.
# ======================================================================= #
      else
      if this_argument.include? '--' # silent pass through.
      elsif this_argument.include? '=' # 03.05.2011
      splitted = this_argument.split('=')
      case splitted[0]
      when 'use_cookbook','usecookbook','ucookbook','ucook'
      use_this_cookbook(splitted[1])
      else
      warn splitted[1]
      end
      exit_program
      end
      end
      end
# ========================================================================= #
# === found_program?
# Will return true if we found the program and false if we
# havent. Will return nil if it is not checked.
# ========================================================================= #
      def found_program?
      return @found_program
      end
# ========================================================================= #
# === use_this_cookbook
# Specify a different cookbook file to be used here.
# To test this:
#   ry php use_cookbook=/Depot/jjj
# ========================================================================= #
      def use_this_cookbook(i)
      if File.file? i
      opne 'Using the cookbook file `'+i+'`.'
      elsif File.directory? i
      opne 'Using the cookbook directory `'+i+'`.'
      end
      database_loader.initialize_dataset(i) # load a new yaml dataset.
      seek_program # already contains the right program, but may
# still contain the wrong path to it.
      end
# ========================================================================= #
# === compile_how
#
# Convenience method to enter the proper path. This is a great method,
# as it combines multiple set-paths into one.
# ========================================================================= #
      def compile_how(how = @compile_how)
      @compile_how = how # since Oct 2011.
      if @run_configure_script # Continue only if the user instructed us to
# do so.
      case how
      when :traditional     then enter_traditional_compile_part
      when :non_traditional then enter_non_traditional_compile_part # gobolinux
      when :user_defined    then enter_user_defined_compile_part
      when :undefined       then enter_user_defined_compile_part(:none)
      end
      end
      end
      def enter_traditional_compile_part
      check_unless_use_another_prefix_is_false
# ======================================================================= #
# Next should be output only if debugging... or not?
# unless database_loader.configure_options.empty?
#   ci ' => The Plain options to configure from the yaml object were: '
#   cii database_loader.configure_options
# end
# --sysconfdir=/etc is only added in traditional build.
# ======================================================================= #
      if CONFIG.append_etc_sysconfdir
      @object_configure_string.append '--sysconfdir=/etc' unless GOBOLINUX_LAYOUT == '1'
      end
# --localstatedir=/var is only added in traditional build and if
# user did not set localstatedir in yaml to false.
      if APPEND_VAR_LOCALSTATEDIR
      if database_loader.localstatedir?
      unless GOBOLINUX_LAYOUT == '1'
      @object_configure_string.check_then_append '--localstatedir=/var'
      end
      end
      end
      if APPEND_SHARE_DATAROOTDIR
# disabled for now...
#   check_then_append('--datarootdir=/usr/share')
      end
      _ = database_loader.configure_options
      @object_configure_string.append _
      unless @object_configure_string.string?.include? '--prefix' # query.configure_options
# Add further Options, but only if configure_options
# includes no --prefix option.
      unless GOBOLINUX_LAYOUT == '1'
      opne 'Appending --prefix=/usr to '+@object_configure_string.string?
      @object_configure_string.append '--prefix=/usr'
      end
      end
      @object_configure_string.sanitize_configure_string
# ci 'System command will be:'
# cii '  '+@object_configure_string.string?
      if @build_type == :configure
# invoke gnu compiling
      invoke_gnustyle_compiling(@object_configure_string.string?)
# Da is irgendwas...
#  check_unless_use_another_prefix_is_false(true)
# database_loader.configure_command kann hier nit '' sein
# HERE, configure is DONE and FINISHED. :)
      cliner {
      opne 'Configure finished using this syntax:'
      opn; cfile @object_configure_string.string
      }
      elsif @build_type == :cmake
      invoke_cmake_compiling '/usr'
      elsif @build_type == :scons
      invoke_scons_compiling '/usr'
      end
      run_premake_commands
# Did we supply different make options? We check here for that.
      unless database_loader.make_options.nil? or database_loader.make_options.empty?
      opne 'Doing different make options next.'
      make_options = database_loader.make_options
      split_character = ','
      if make_options.count(';') > make_options.count(split_character)
      split_character = ';' # If we see more ; than , we use that as split character.
      end
      make_options.split(split_character).each { |make_option|
# if make_options contains rconf, then we will use rconf
# as means to configure the program.
      if make_option == 'rconf'
      opn; ci 'Doing RConfigure next: '
      if database_loader.override
      invoke_ruby_new_configure(options)
      elsif @use_another_prefix.false?
      invoke_ruby_new_configure(options)
      else
      opn; warn 'DEBUG: Invoking gnu compiling in line '+
      __LINE__.to_s+', is all OK?'
      invoke_gnustyle_compiling(options)
      end
      end
      case make_option # Handle special cases now.
      else # Else, default.
      opn; cif "Doing `#{make_option}` for "; f database_loader.program_name
      opn; cif 'in '; cdirf Dir.pwd; ci ' next:'
      sys(make_option, @use_systemu, :def, __FILE__)
      end
      }
      else
      run_make_and_make_install_command if @continue_after_configure_phase
      end
      end
      def enter_non_traditional_compile_part
      invoke_create_program # to create our skeleton dir structure
      tmp_name = ProgramInformation.new(database_loader.program_name)
      tmp_name = tmp_name.name
# ======================================================================= #
# Must sanitize the name before continuing.
# This means removing - and {, and a bit more.
# This method is defined in RBT_Base.rb
# ======================================================================= #
      tmp_name = sanitize_program_name(tmp_name, CONFIG.capitalize_program_name)
# Must assign a new name if our yaml file overrules it:
      unless database_loader.use_this_program_name.empty?
      tmp_name = database_loader.use_this_program_name
      end
# ======================================================================= #
# If @use_another_prefix is not false, then we set a value.
# ======================================================================= #
      if @use_another_prefix
      check_unless_use_another_prefix_is_false
      else # Else we modify our prefix here.
      _ = PROGRAMS_DIR
      tmp_name = tmp_name.downcase.cap if CONFIG.capitalize_program_name # set proper capitalized name
      _ << tmp_name
      _ << '/'+database_loader.program_version
      unless database_loader.configure_options.include? '--prefix'
      @object_configure_string.do_not_use_a_prefix if @do_not_use_a_prefix
      @object_configure_string.modify_prefix(_)
      end
      end
# ======================================================================= #
# Append further configure options to our configure string.
# ======================================================================= #
      @object_configure_string.append database_loader.configure_options
# ======================================================================= #
# Now that we passed the important things to RubyRConfigure,
# the next thing is to invoke the symlinking part. But
# before we finish here, we must check if our dir is empty.
# To do so we check if the link to Current is empty or not - see below.
# ======================================================================= #
      target_dir = (CONFIG.programs_dir+'/'+tmp_name).gsub(/-/,'')
      target_dir_current = target_dir+'/Current'
      if @build_type == :configure
      invoke_gnustyle_compiling(@object_configure_string.string)
      elsif @build_type == :cmake
      invoke_cmake_compiling(@object_configure_string.prefix)
      do_premake_make_and_make_install if @continue_after_configure_phase
      elsif @build_type == :scons
      invoke_scons_compiling(@object_configure_string.prefix) # prefix could be /Programs/Ardour/2.3.1
      do_premake_make_and_make_install if @continue_after_configure_phase
      elsif @build_type == :ruby
      do_premake_make_and_make_install if @continue_after_configure_phase
      else
      warn 'Unknown build type: '+@build_type.to_s
      end
# ======================================================================= #
# The following three methods are temporarily disabled until
# i fix the bug that puts them there - even if 0 is installed,
# or if it was a ruby file.
#   create_architecture_file(target_dir_current) # will generate the Dependencies file. Gobolinux wants that.
# ======================================================================= #
      if @run_simulation
      elsif Dir.empty? target_dir_current
      opn; warnf '=> Removing '; cdirf target_dir; warn ' because it has no content.'
      remove_directory(target_dir)
      end
# ======================================================================= #
# First, go to target dir, then symlink
#   bl $RBT/AdvancedSymlink.rb
# Sanitize potential symlinks first.
# ======================================================================= #
      if File.symlink? target_dir_current
      target_dir_current = Pathname.new(target_dir_current).realpath.to_s
      end
# ======================================================================= #
# Since Jan 2012 we create the file .VERSION_TO_USE to denote the active
# version which we will use. This way, we no longer depend on a symlink
# in question per se. Instead, the information as to which version we
# will use is directly stored in a file.
# ======================================================================= #
      version_to_use = target_dir+'/.VERSION_TO_USE'
      remove(version_to_use) if File.exist? version_to_use
      append_what_into(database_loader.version?, version_to_use)
      @advanced_symlink = AdvancedSymlink.new(target_dir_current)
      save_installed_files_information(target_dir_current)
      save_compile_time_information(target_dir_current)
# ======================================================================= #
# Next create a package and dump it into /Depot/Packages
# ======================================================================= #
      cliner {
      _ = @object_configure_string.prefix
      e 'Packaging up `'+_+'` next into '+PACKAGES_DIR+'.'
      change_directory PACKAGES_DIR
      ToTarBz2.new(_, false, true).create_tarbz2_package
      } if CREATE_PACKAGE && ! CONFIG.use_stow # Conditional here.
      if @installation_was_successful_or_not
      opn; e 'Installation of '+database_loader.program_name?+' has '+
      'finished into '+target_dir_current
      end
# ========================================================================= #
# === invoke_gnustyle_compiling
#
# Normally, this method will invoke the following build chain:
#
#     "configure"
#     "make"
#     "make install"
#
# It uses obligate options which are passed to it. By the way, instead of
# make, the user can denote an alternative program, like qmake, or cmake.
# But in general, make is the default option and will thus be used most
# often.
# ========================================================================= #
      def invoke_gnustyle_compiling(configure_options)
      this_dir = database_loader.extract_to.dup
# Always squeeze the configure command before continuing.
      @object_configure_string.sanitize_configure_string # exchanges '  ' with ' '
      unless database_loader.use_this_build_directory.empty?
      this_dir = this_dir.split('/')[0..-2].join('/')
      @configure_prefix = '../' # adapt configure prefix
      end
      @configure_string = @object_configure_string.string?
      if File.exist?(this_dir) # if TEMP_DIR exists?
# At this point, append the two
# prepend to @configure_command
      if check_for_configure_script(this_dir) # if a configure script could be found and invoked true
      cliner {
      opn; f 'DEBUG in Installer.rb:'; e @configure_string
      } if @debug
      check_for_exclusive_logic = ExclusiveLogic.new(@configure_string) # bl $RBT/Exclu*
      check_for_exclusive_logic.force_add @stringified
      @object_configure_string.string = check_for_exclusive_logic.string
      @configure_string = @object_configure_string.string?
      check_for_exclusive_logic.no_problems # Since 06.11.2011 we overrule this here.
      if check_for_exclusive_logic.problems?
      first  = check_for_exclusive_logic.duplicates[0]
      second = check_for_exclusive_logic.duplicates[1]
      opn; warn 'The configure options: '
      opn; warn '  '+first.to_s+' and '+second.to_s+' are mutually exclusive.'
      opn; warn 'Please fix this ambiguity first before we can continue!', T # true for exit.
      end
      cliner { opn; f 'Invoking gnu compiling next.' }
# =================================================================== #
# Now actually run the configure string string.
# =================================================================== #
      if @run_configure_script
      if @run_simulation
      opne 'Normally we would run the configure command above now '+
      'but since'
      opne 'we are in simulation mode, we will not run it.'
      else # ============================================================ #
# Check if a configure script exists. Remember though, we must
# check its absolute location - we could have entered a BUILD/
# directory meanwhile, so this would not work.
# ============================================================ #
      _ = this_dir
# =============================================================== #
# We also have to check whether we have a build directory.
# =============================================================== #
      if database_loader.use_build_directory
      _ << database_loader.use_this_build_directory
      end
      _ << database_loader.short_name+'-'+database_loader.program_version+ '/configure'
      if ! File.exist?(_)
      _ = @base_dir
      end
      if File.exist? _
# ============================================================= #
# Preparing to do the @configure_string command now.
# (Configure tag)
# ============================================================= #
      opn; cif 'Doing `'; ciif @configure_string; ci '`'
      opn; cif 'next from '; cdir File.dirname(_)
      result = sys(@configure_string, @use_systemu, :def, __FILE__)
      @continue_after_configure_phase = result # check for error here.
# Note that this can be a problem though, in case such as perl.
# We will thus use something else instead. For now as a hack,
# if we find pre_make_command not empty, we overrule the result
# here:
      unless database_loader.pre_make_commands.empty?
      @continue_after_configure_phase = true
      end
      else # Else we found no configure script here.
      opn; warn 'Can not run ./configure as no configure script could be found at'
      opn; warn _+'.'
      end
      end
      end
      end
      do_premake_make_and_make_install if @continue_after_configure_phase
      else
      opn; cdirf this_dir
      warn ' does not seem to exist.'
      opn; warn 'Has the archive been properly extracted?'
      end
      end
# ========================================================================= #
# === invoke_cmake_compiling                                    (cmake tag)
# Ensure that prefix is correct before passing it to this method.
# It will set a new prefix to our cmake string.
# ========================================================================= #
      def invoke_cmake_compiling(prefix = '/usr')
      opn; target_directory = rds(@data['extract_to']+'/'+
      @data['sub_dir']+'/'+
      @data['program_name'])
      if cmake_string?.check_if_cmakelists_file_exists?(target_directory) # check if cmake file exists.
      cmake_string?.check_if_cmake_is_available # HMMM isn't this bad? This should be inside the logic of Cmake...
      cmake_string?.set_prefix prefix
      cmake_string?.set_base_directory TEMP_DIR+@data['program_name']
      cmake_string?.run_full
      else
      opn; warnf 'CMakeLists.txt file does not exist in '; cdirf target_directory
      warn '.' # Since Oct 2011 we delegate to GNU autoconfigure.
      opn; warn 'We thus delegate to GNU Configure again, in an attempt to still '
      opn; warn 'compile the program.'
      @build_type = :configure
      compile_how
      end
      end
# ========================================================================= #
# === check_unless_use_another_prefix_is_false
#
# This is a convenience method which accepts one argument, called
# `behaviour`, which defaults to false.
# If behaviour is true, then we check for --prefix given in
# configure_options. After it does these checks, it invokes
# modify_prefix, and modifies the prefix (except if our --prefix
# command already uses the same information.
# In that case, it does leave the information as it was. Also please note
# that this method must be called at least ONCE successfully, to set a
# default prefix specified for use in @use_another_prefix.
# Since as of 11 AUG 2006, @prefix has changed and may now include the
# --prefix for a package.
# ========================================================================= #
      def check_unless_use_another_prefix_is_false(behaviour = false)
# Wenn override true is ...
      if database_loader.override.true?
      cii ' => Overriding prefix settings from RYamlNewSourcerMaker.rb.'
      if database_loader.prefix == true
# der unless check is ne sicherheit, um nit 2 mal
# --prefix=/ zu adden
      unless database_loader.configure_options.include? 'prefix'
      @object_configure_string.do_not_use_a_prefix if @do_not_use_a_prefix
      @object_configure_string.modify_prefix(@use_another_prefix) unless @use_another_prefix.false?
      end
      elsif database_loader.prefix == false
# passthru
      else
      unless database_loader.configure_options.include? 'prefix'
      @object_configure_string.do_not_use_a_prefix if @do_not_use_a_prefix
      @object_configure_string.modify_prefix database_loader.prefix
      end
      end
      else # no override given
      if @use_another_prefix
# interesting idea: We manipulate the object directly.
# This may be a good idea, not sure yet. I think though
# that it is easier to not modify it.
      unless database_loader.configure_options.include? 'prefix'
      opn; cif '=> Adding another prefix: '
      cii @use_another_prefix
      debug 'The old configure command was: '+@object_configure_string.string?
      @object_configure_string.do_not_use_a_prefix if @do_not_use_a_prefix
      @object_configure_string.modify_prefix @use_another_prefix
      end
      end
      end
      end
# ========================================================================= #
# === feedback_urls
# ry htop feedback_urls
# ========================================================================= #
      def feedback_urls(i = %w( sushi cheese gnomedocuments totem empathy gnomegames ) )
      opne 'Fetching URLs now for these programs:'
      opne '  '+i.join(', ')
      i.each { |f|
      @query.check_for(f)
      database_loader.feedback_url
      }
      end
# === reset.rb
#
# of RBT::Compile
      require 'rbt/misc/colourize_parser.rb'
      require 'rbt/compile/prefix.rb'
      module RBT
      class Compile < Base
      def reset
      super()
      set_program # Set to nil initially.
      reset_prefix_variables # Default to prefix "nil".
# ======================================================================= #
# === Whether to use Opn or whether we will not
# ======================================================================= #
      RBT.do_show_the_classname # Yes, do use Opn.
      @continue_after_make_step = true
# ======================================================================= #
# Next, we can determine the main prefix in use.
# ======================================================================= #
# set_use_this_prefix # This has to be set to initialize it.
      @may_we_run_make_install_command = true
      @continue_after_configure_step = true # So we continue after configure phase.
      @extra_compilation = false # if true then we will compile again via app-dir prefix. This is enabled to allow both trad_and_ntrad
# ======================================================================= #
# We also need a way to stop after the make-step. This is why
# the following instance variable is used.
# ======================================================================= #
      @continue_after_make_step = true
      @configure_stage_was_a_success = false
      @make_stage_was_a_success = false
      @make_install_stage_was_a_success = true # Default value.
      end
# ========================================================================= #
# === return_default_internal_hash
#
# This method returns the default entries to be used for the internal
# hash. The reason as to why this is a separate method is mostly so
# that we can query its value from the commandline as well.
# ========================================================================= #
      def return_default_internal_hash
      internal_hash[:make_options] = nil # By default, we won't use additional make options.
      internal_hash[:configure_base_directory] = nil
      internal_hash[:rename_tab_title] = CONFIG.rename_tab_title
      internal_hash[:use_this_specific_program_version] = nil # Initial value.
      internal_hash[:skip_extracting] = nil # Nil on startup.
      internal_hash[:full_configure_command] = ''
      internal_hash[:make_command] = nil # This means that we can change it.
      internal_hash[:program_compile_name] = nil # <- Not sure if we need this.
# ======================================================================= #
# By default, we will not make use of Cookbook aliases. This will be
# changed at a later step, when we actually DO compile a program.
# ======================================================================= #
      internal_hash[:make_use_of_cookbook_aliases] = false
# ======================================================================= #
# The following entry means that we will attempt to recompile the
# program if an error happens, IF this error can be fixed
# automatically. This currently only works for libtool-related errors
# but in the future, this functionality may be extended to also
# auto-recompile in the event of other problems.
# ======================================================================= #
      internal_hash[:try_to_recompile_upon_error] = true
      internal_hash[:invalid_libtool_archive] = nil
      internal_hash[:remove_la_files_after_compilation] = false
      internal_hash[:try_to_autofix] = config?.use_autofixing # Whether we will try to autofix problems.
      internal_hash[:run_configure_script] = true
# ======================================================================= #
# internal_hash[:use_this_build_directory] = nil
# ^^^ this is handled via class BuildDirectory since as of July 2018.
# ======================================================================= #
      internal_hash[:may_we_modify_the_full_configure_command] = true
      internal_hash[:configure_command] = 'configure'.dup
      internal_hash[:use_this_make_command] = 'make'
      internal_hash[:symlink_glib_schema] = false
# ======================================================================= #
# If @do_not_symlink is set to true then we won't symlink after
# the "make install" phase.
# ======================================================================= #
      internal_hash[:do_not_symlink] = false
      internal_hash[:install_only_binaries] = false # Install only the bin/ directory.
      internal_hash[:run_make] = true # By default, we will try to run make.
      internal_hash[:may_we_log] = true
      internal_hash[:upload_binaries] = false
      internal_hash[:dataset] = nil # Must be nil initially.
      internal_hash[:exit_after_a_rubygem_has_been_installed] = true
# === rbt/compile/set_compile_these_programs.rb#
      require 'rbt/toplevel_methods/run_makepkg_command.rb'
      require 'rbt/toplevel_methods/remove_archive_from_the_end.rb'
      module RBT
      class Compile < Base
# ========================================================================= #
# === compile_these_programs?
# ========================================================================= #
      def compile_these_programs?
      ihash?[:compile_these_programs]
      end; alias compile_these_programs compile_these_programs? # === compile_these_programs
# ========================================================================= #
# === use_pwd_as_input
# ========================================================================= #
      def use_pwd_as_input
      set_compile_these_programs('PWD')
      end
# ========================================================================= #
# === set_compile_these_programs
#
# The second argument to this method can be used to determine how we
# will treat the first input argument.
#
# For example, the Symbol :do_reassign_other_commands_to_input_for_the_menu
# to the second argument will cause this method to only use the first
# entry of the first argument, and simply re-assign the other arguments
# onto the commandline arguments.
#
# If the input contains a '#' character then we will ignore everything
# that came after this character.
# ========================================================================= #
      def set_compile_these_programs(
      i                    = []
      )
      i.map! {|entry|
# ===================================================================== #
# First, check whether this program is not included normally, but
# only as an alias.
# ===================================================================== #
      unless Cookbooks.does_include?(entry, :ignore_aliases)
      if Cookbooks.does_include?(entry) and make_use_of_cookbook_aliases?
# ================================================================= #
# So we now know that it may be an alias.
# ================================================================= #
      old_name = entry.dup
      entry = return_alias_name_for(entry)
      opne 'Renaming '+sfancy(old_name)+' to its '\
      'alias name '+sfancy(entry)+'.'
      end
      end
# ===================================================================== #
# The cookbook may not include the sought-for program.
# Thus, we attempt to rewrite the given input here.
# ===================================================================== #
      unless does_include? entry
# =================================================================== #
# There are some possibilities that the program exists already,
# just via another name. An example for this may be if the
# user did input "libuhttpmock", which already exists as the
# name "uhttpmock". The first check will test this case.
# =================================================================== #
      if entry.start_with?('lib') and
      does_include?(entry.sub(/^lib/,''))
      entry.sub!(/^lib/,'')
# ================================================================= #
# Must also notify the user about this change, though. Transparency
# is important.
# ================================================================= #
      opne 'We have found a variant name that is '\
      'included ('+sfancy(entry)+') - using this one instead.'
# =================================================================== #
# Check if there is a program starting with 'lib'.
# =================================================================== #
      elsif does_include? 'lib'+entry
      entry = return_corresponding_lib_input(entry)
      else
# ================================================================= #
# === Handle cookbook aliases next
# ================================================================= #
      unless does_include? 'lib'+entry
      new_entry = find_cookbook_alias_for(entry)
      if new_entry # Ensure that something has been found.
      unless new_entry == entry
      opne 'Using the alias '+sfancy(new_entry)+
      ' for '+sfancy(entry)+' instead.'
      entry = new_entry
      end
      end
      else
# =============================================================== #
# === Check whether there is a binary name
# =============================================================== #
      if Cookbooks.does_include_this_binary?(entry) and
      !(Cookbooks.all_binaries?[entry] == entry)
      entry = Cookbooks.all_binaries?[entry] # Re-assign it here in this case.
      end
      end
      end
      end
      ensure_that_the_program_exists(entry)
      entry # Must return it here.
      }
      ihash?[:compile_these_programs] = i
# ======================================================================= #
# Set at the least to the name of the irst program.
# ======================================================================= #
      set_program_name(ihash?[:compile_these_programs].first)
      end
      end; end
# === installer.rb
      class Installer
# ========================================================================= #
# === reset                                                     (reset tag)
#
# Call it only when @_ was set.
# ========================================================================= #
      def reset
      @aliases = Aliases.new(@_) # For this to work, @_ must be set before calling it.
      @aliases.be_silent
      @do_not_use_a_prefix = false
      @make_command = 'make' # Usually this is make. Sometimes it may be gmake.
      @continue_after_configure_phase = true # By default, we will continue after configure.
      @use_this_build_directory = nil
      @configure_prefix = '' # Normally we use ./configure, but sometimes.
      @use_flags = UseFlags.new # bl $RBT/use_flags.rb
      @logger = Logger.new
      @install_package = InstallPackage.new # Install new packages bl $BT/lib/install_package*
      end
# ========================================================================= #
# === menu
# ========================================================================= #
      def check_action_against_menu(i)
      case i
# ======================================================================= #
# ry php graph
# ======================================================================= #
      when 'graphviz_create_image','graphviz','graph'
      create_graphviz
      exit_program
# ======================================================================= #
# ry python register
# ry htop register
# ======================================================================= #
      when 'register','reg','do_register','doregister'
      register_this_program(@_)
      exit_program
# ======================================================================= #
# Same as above, but with libraries.
# ry atk library?
# ======================================================================= #
      when 'check_for_library','library?'
      check_for_library
      exit_program
# ======================================================================= #
# Copy the whole yaml file:
#   ry x gcy
# ======================================================================= #
      when 'copy_yaml',
      'copyyaml','clone','dump_yaml','dyaml','generate_yaml',
      'generate_custom_yaml','gcy','to_yaml','generateyaml'
      database_loader.generate_custom_yaml(:all) # bl $BT/database_loader.rb
      exit_program
# ======================================================================= #
# Since 29.04.2009 we will also search in the cookbook files.
# ry gcc search?
# ======================================================================= #
      when 'find','find?','file?','file','search','s?',
      'search?','sear','sea','s','suche'
      search
      exit_program
# ======================================================================= #
# ry htop tut
# ======================================================================= #
      when 'tutorial','tut'
      require 'bt/interactive_tutorial.rb'
      InteractiveTutorial.new
      exit_program
      else # Else tag.
# Specify a build dir
#   ry pango --subdir=HIII
      when 'set_build_dir','build-dir','build_dir','subdir'
      method_name = 'use_specific_build_directory'
      end
      argument_to_the_method = splitted[1]
      if self.respond_to? method_name.to_sym
      self.send method_name.to_sym, argument_to_the_method
      else
      warning_argument_was_not_found(i)
      end
      end
      end
      end
# ========================================================================= #
# === search_in_cookbook_files
# Wrapper towards class SourceDefinition.
# ========================================================================= #
      def search_in_cookbook_files(search_term)
      SourceDefinition.new(search_term)
      end
# ========================================================================= #
# === run_configure_script                      (configure tag, config tag)
#
# You must call set_prefix() before calling this method. Also note that
# we will respect @run_configure_script, but we do so silently without
# reporting to the user in the event that he overruled this setting on his
# own.
# ========================================================================= #
      def run_configure_script
      if @run_configure_script
      opnef 'Now running configure script from '; cdirf Dir.pwd; e ':'
      @configure_string.do_not_use_a_prefix if @do_not_use_a_prefix
      @configure_string.modify_prefix(@prefix)
      @configure_string.leading_part = @configure_prefix unless @configure_prefix.empty?
# Fetch the configure options. Append them simply.
      @configure_string.append(@data['program_name'].configure_options)
      _ = @configure_string._
      opne '  '+_
      sys(_)
      end
      end
# ========================================================================= #
# === abort_unless_this_directory_exists
#
# This will abort, unless the given directory exists. Only used once
# though.
# ========================================================================= #
      def abort_unless_this_directory_exists(directory)
      if run_simulation?
# opn; ci 'We are in simulation mode!' # so we pass through.
      elsif File.directory?(directory)
# continue normal way. The directory exists, thus things seem to look ok.
      else # Since Oct 2011 we try to use FindLikelyDirectory.
      _ = FindLikelyDirectory.new(directory) # But perhaps remove this.
      if _.found_match?
      set_base_dir(_.match)
      else
      opn; warn 'Can not skip extracting directory `'+sdir(directory)+'`'
      opn; warn 'because it does not exist.'
      exit_program
      end
      end
      end
# ========================================================================= #
# === start_compiling
#
# This method starts the compiling procedure.
# ========================================================================= #
      def start_compiling
#set_program_to_compile(@aliases.real_alias) # sync it here. HMM.
      opnef 'Now compiling `'; fancyf @_; e'`.'
      @data = SanitizeProgramEntry.new(@_, data)
# @query = Query.new(@program_to_compile) # This must be looked into still.
      set_prefix # On startup and reset(), we set the @prefix variable.
# ======================================================================= #
# Next we need to account for use-flags before compiling more.
# ======================================================================= #
      add_use_flags
# ======================================================================= #
# Run as a specific user.
# ======================================================================= #
      run_as_user(CONFIG.run_as_user) if CONFIG.run_as_user
# ======================================================================= #
# Check if our source-tarball exists.
# ======================================================================= #
      check_if_source_exists
# ======================================================================= #
# Start to log.
# ======================================================================= #
      start_logging if CONFIG.shall_we_log
# ======================================================================= #
# Here we check whether we should copy the source or not. This happens
# before we extract the source.
# ======================================================================= #
      copy_source if @data['copy_source']
# ======================================================================= #
# Next decide whether to extract the source archive or not.
# ======================================================================= #
      consider_extracting_program
      _ = TEMP_DIR+'/'+@data['program_name'].program_name
      set_base_dir(_)
# ======================================================================= #
# Ok, we are NOW convinced that the user really wants to install the
# program, and we have found it in our cookbook.yml
# We now need to satisfy one more point:
#   - Is our directory actually available?
# The user could have issued `skip_extracting` in which case the target
# directory would not be available. Or the directory could be incorrectly
# set, which sometimes happens with source packages.
# ======================================================================= #
      abort_unless_this_directory_exists(@base_dir)
      cd @base_dir # This works because we used set_base_dir() before.
      consider_entering_special_build_directory
# ======================================================================= #
# If the configuration option enable_shared is true, the next method will
# properly append this to the configure string.
# ======================================================================= #
# ======================================================================= #
# Next we must decide what to do - run GNU Autoconfigure? Or cmake?
# ======================================================================= #
      decide_whether_to_run_gnu_autoconfigure_or_something_else
      if @continue_after_configure_phase
      run_make_and_make_install_command
# ===================================================================== #
# After we finished to compile, we will try to run all possible
# postinstall actions, as we may kill dirs afterwards
# ===================================================================== #
      invoke_postinstall
      end
# ========================================================================= #
# === set_version
# Use this to set a specific version. The argument v is the specific
# version you wish to set. Since Jan 2012 we get rid of stuff like
# .tar or .gz.
# ========================================================================= #
      def set_version(i)
      i = i.sanitized_without_extension # Necessary sanitizing.
      @flag_set_different_version = i
      opn; cif 'Setting to a new, specific version: '
      important @flag_set_different_version
# The next lines are experimental.
#  database_loader.set_program_version(@flag_set_different_version, true) # true for "propagate_change"
#  database_loader.modify_urls(@flag_set_different_version)
      end
# ========================================================================= #
# === determine_build_type
#
# Use this method to determine the build type. "dependencies" should be an
# array but can also be nil. "extra_information" will be used to determine
# sub-types. I am not sure if this is needed though, lets see.
# Possible build types so far are:
#       configure, cmake, scons, ruby
# ========================================================================= #
      def determine_build_type
# @build_type can be :configure :cmake :scons :perl :ruby :haskell
#
# Inside these general build types you can use subtypes, for example,
# :ruby1 means to install in RINSTALL1 fashion, :ruby2 means to
# install in RINSTALL2 fashion.
#
# By default it is :configure which means "GNU autoconfigure based
# system. We need to be careful here, to ensure that the @build_type
# will be correct.
      dependencies = @data['required_deps_on']
      if dependencies
      if    dependencies.include? 'cmake'
      @build_type = :cmake
      elsif dependencies.include? 'scons'
      @build_type = :scons
      elsif dependencies.include? 'ruby'
      @build_type = :ruby
      end
      if @debug # Only report the following if we are in DEBUG mode.
      opn; f 'The build type for '+@_+' is: '+@build_type.to_s+' type'
      end
      end
      end
# ========================================================================= #
# === add_use_flags                                   (cflags tag, use tag)
# This method will add use flags to our configure string.
# ========================================================================= #
      def add_use_flags
      @parse_configure_help = ParseConfigureHelp.new
      @parse_configure_help.sanitize_string
      cflags = @use_flags.string
# clags can be i.e.:
#   --without-arts --enable-lame --enable-ogg
      if @parse_configure_help.include? cflags
      @configure_string.append cflags
      else # else also look if we have ' '
      if cflags.include? ' '
      cflags.split(' ').each { |splitted|
      if @parse_configure_help.include? splitted
      @configure_string.append splitted
      end
      }
#else # else really not included
      end
      end; private :add_use_flags
# ========================================================================= #
# === disable_logging
# ========================================================================= #
      def disable_logging
      CONFIG.shall_we_log = false
      end
# ========================================================================= #
# === start_logging                                               (log tag)
#
# Invokes Logger. Prepare_program invokes this method if the constant
# was set. Usually defaults to:
#
#   /System/Logs/AllInstalledSourceFiles.html
# ========================================================================= #
      def start_logging(log_all_installed_source_files_html = LOG_ALL_INSTALLED_SOURCE_FILES_HTML)
      log_all_installed_source_files_html = rds(log_all_installed_source_files_html) # Dont want two //
      base_dir = File.dirname(log_all_installed_source_files_html)
      if File.writable?(base_dir)
      if run_simulation?
# short version.
      _ = ProgramInformation.new(@data['program_name'])
      name = _.name
      simulation_summary = CONFIG.store_into_this_directory+'SimulationSummary.html'
      opn; cif 'We would have logged into '; cfile simulation_summary
      _  = '<b id="'+name+'">'+name+"\n<br>"
      _ << " - #{@data['program_version']}</b>\n<br> "
# append_what_into(_, simulation_summary)
      else # normal mode, ist wichtig for /System/Information/LastCompiledProgram.html
      opn; cif 'Logging into '; cfile log_all_installed_source_files_html
      remove_file( CONFIG.file_last_compiled_program )
      unless File.exist? File.dirname(log_all_installed_source_files_html)
      create_directory File.dirname(log_all_installed_source_files_html)
# Write a header if file does not yet exist
      _ = Cyberweb.html_comment('Generated from '+File.basename(__FILE__))
      write_what_into(_ , log_all_installed_source_files_html)
      _ = Cyberweb.html_comment('Will list all compiled programs by the BT Scripts')
      append_what_into(_ , log_all_installed_source_files_html)
      end
# =================================================================== #
# Here information über /System/Information/LastCompiledProgram.html
# =================================================================== #
      _ = "<!-- ProgramName: #{@data['program_name']} -→ \n"
      _ << "<html><title>#{CONFIG.file_last_compiled_program}</title><body>"
      _ << Cyberweb.string_div('','padding-top:3em;margin-top:10em;')+
      Cyberweb.string_s('The last compiled program was ','b','','padding-left:1em')+
      Cyberweb.string_br+
      '<span style="padding-left:3em">'+@data['program_name']+'</span>'
      the_url = @data.remote_urls.last.to_s
      program_information = Cyberweb.string_br+
      '<b style="padding-left:1em">Program Description</b>'+
      Cyberweb.string_br+
      sload.description+
      Cyberweb.string_br+'<div>'+
      '<b style="padding-left:1.15em; ">Program URL</b><br>'+
      '<a href="'+the_url+'">'+
      sload.remote_urls.join("\n<br>\n")+
      '</a>'+'</div>'
      unless sload.configure_options.to_s.empty?
      program_information << '<div><h4 style="margin-bottom:3px">Configure Options to '+
      sload.program_name+':</h4>'+
      '<span style="margin-left:3em">'+sload.configure_options.to_s+'</span>'
      end
      program_information << '</div>'
      _ << program_information
      _ << Cyberweb.string_br
      _ << '</div>'
      _ << Cyberweb.sclose('body')
      @information_about_last_compiled_program = _ # _is shorter  :D
# ===================================================================== #
# Finally, write the data into the log files.
# ===================================================================== #
      write_what_into(@information_about_last_compiled_program,
      CONFIG.file_last_compiled_program)
      str = "<b id=\"#{sload.program_name}\">#{sload.program_name}</b> "+
      'has been started to get configured at '+
      Cyberweb.string_s(return_date,'b').chomp+'.'+N
      append_what_into(str+N+program_information, log_all_installed_source_files_html)
      append_what_into('=' * 80+"<br>"+N, log_all_installed_source_files_html)
      end
      else
      opn; warnf 'Can not create file '; cfile log_all_installed_source_files_html
      opn; warn 'because of insufficient permissions.'
      end
      end
# ========================================================================= #
# === decide_whether_to_run_gnu_autoconfigure_or_something_else
#
# Here we decide what to use.
# ========================================================================= #
      def decide_whether_to_run_gnu_autoconfigure_or_something_else
# dependencies = sload['required_deps_on'] # This is (or should be) a string.
# But why is it needed?
      case @build_type
      when :configure # This is the default.
      run_configure_script
      when :cmake
      run_cmake
      end
      end
# ========================================================================= #
# === find_all_packages                                          (find tag)
#
# This method will look at available_programs of database_loader
#
# The `matching` argument could be "ruby", then we feedback all
# related to ruby.
#
# Usage examples:
#   ry gc search?
#   ry ruby se
# ========================================================================= #
      def find_all_packages(matching)
      @array_found_entries =
      all_programs.find_all { |t| t =~ /#{matching}/}
      cliner {
      opn; cii 'We have the following programs in our repository matching '
      opn; ciif 'the search string `'; ff matching; cii '`'
      } unless @array_found_entries.empty?
      @array_found_entries.each_with_index { |array_entry, index|
      tmp = ( '%03s' % (index+1) ).to_s
      tmp_array_entry = '%12s' % array_entry
      print "#{tmp}: #{tmp_array_entry}"
      seek_program(array_entry)
      print ' ==> '
# Now print all up to the first '.'
      description = sload.description?
      _ = ''
      _ << description if description # .remove.cut # remove kills \n, cut removes leading " and trailing "
      cut_at_this_length = 60
      _ = _[0, cut_at_this_length] if _.size > cut_at_this_length
      e _.chomp
      }
      end
# ========================================================================= #
# === search                                                   (search tag)
# ========================================================================= #
      def search
      find_all_packages @_
      opne 'We will also search in our cookbook files for the '+
      'entry `'+@_+'` next.'
      search_in_cookbook_files @_
      end
# ========================================================================= #
# === toggle_debug
# ========================================================================= #
      def toggle_debug
      case @debug
      when true  then @debug = false
      when false then @debug = true
      end
      opne "Changing @debug variable to `#{@debug}` now."
      save_yaml(DEBUG_FILE, @debug)
      exit_program
# ========================================================================= #
# === use_specific_build_directory
#
# We use this to set a specific build directory. The first argument
# defines the location of the build directory.
# ========================================================================= #
      def use_specific_build_directory(i = DEFAULT_NAME_BUILD_DIRECTORY, be_verbose = true)
      i = DEFAULT_NAME_BUILD_DIRECTORY if i.nil? # default
      if be_verbose
      opne 'We will use the build directory `'+sdir(i+'/')+'`.'
      end
      @use_build_directory = T
      @use_this_build_directory = i
      sload.use_build_directory = @use_build_directory
      sload.use_this_build_directory = @use_this_build_directory
# ======================================================================= #
# === consider_entering_special_build_directory
#
# Do we need a new directory? use_this_build_directory will tell us if
# we need one or not. It will be assigned to the var _, and we will
# enter this dir in this case.
# ======================================================================= #
      def consider_entering_special_build_directory
      if sload.use_build_directory
      _ = sload.use_this_build_directory
      _ = DEFAULT_NAME_BUILD_DIRECTORY if sload.use_this_build_directory.empty? # overrule here.
      opn; cif 'Using the special build directory called: `'; cdirf rds(@base_dir+'/'+_); e '`'
      if run_simulation?
      opn; cif 'We would now create the directory '; cdir _
      opne 'But since we are running in simulation mode, we '+
      'will not create it.'
      else
      if File.exist? _ # First, remove the old directory if it exists. This is useful for
      opnef 'The build-directory '; cdirf _+'/'; e ' already exists.'
      opne 'We remove it so that we can make a fresh start.'
      remove_directory _
      end
      create_directory _ # Now create this directory.
      end
      set_base_dir(@base_dir+'/'+_)
      opn; cif 'Now changing dir to the directory '; cdir @base_dir
      opn; cif '  (Absolute directory will be '; cdirf @base_dir;ci ')'
      if run_simulation?
      opn; cif 'We would now change into the directory '
      cdir @base_dir
      e 'But since we are running in simulation mode, '+
      'we will not change int this directory.'
      else
      change_directory @base_dir
      end
      @configure_prefix = '.' # overrule configure prefix too
      end
# ========================================================================= #
# === check_for_enable_shared
#
# For this method to work properly, enable_shared must be either true or
# false.
# ========================================================================= #
      def check_for_enable_shared
      @configure_string.append '--enable-shared' if sload.enable_shared
      end
# ========================================================================= #
# === register_this_program                                  (register tag)
#
# Wrapper towards Register. Use this method consistently when wanting
# to register a program from within Installer.rb.
# ========================================================================= #
      def register_this_program(program)
      if CONFIG.register_compiled_program
      register = Register.new(program)
      register.run_simulation = run_simulation?
      register.register if @continue_after_configure_phase
      else
      opne 'Not registering `'+program+'` because we have '\
      'disabled that in the config file.'
      end
      end
# === install_package.rb
#
# - Purpose of this class:
#
# Installs a package residing in /Depot/Packages. You can however give a
# package on commandline, and then it will install this instead of a
# "normal" install.
# Usage:
#   rinst all
#   rinst make.tar.bz2
# ======================================================================= #
      module RBT
      class InstallPackage
# ========================================================================= #
# === initialize
# init section
# ========================================================================= #
      def initialize(arguments = '')
      reset
      set_arguments(arguments)
      check_arguments
      install_package unless @arguments.nil?
      end
# ========================================================================= #
# === reset
# ========================================================================= #
      def reset
      @pkg_dir = PKG_DIR
      @install_mode = '' #
      @symlink_into = '' # empty default
      end
# ========================================================================= #
# === check_arguments
# You can supply either one or more arguments, or no argument.
# If no argument is passed, then we assume we have to install
# everything (this is for your typing convenience). This method is not
# automagically called, you have to call it on your own.
# ========================================================================= #
      @install_mode = :everything
      check_for_specific_arguments
      end
      case @install_mode
      when :everything then ci 'Installing everything.'
      when :one_package_different_symlink
      opn; ci 'Installing one package into another target directory.'
      end
      end
# ========================================================================= #
# === install_package
#
# installs a package. @install_mode can be the location
# of a package.
#
# Some usage examples:
#
#   rinst gcc-3.4.6-paco.tar.bz2
#   rpack zsh-4.3.4-GoboLinuxStyle-paco.tar.bz2 --to=/pkg
#
# ========================================================================= #
      def install_package
      case @install_mode
      when 'everything','e','all','a','alles', :everything
      install_every_package
      symlink_packages(@install_mode) # can be found in bl $RUBY_RUBY_BUILD_TOOLS/RBT_Base.rb
# symlink
      when :one_package_different_symlink
      do_real_install(@arguments, @symlink_into)
      else
      do_real_install(@arguments)
      symlink_packages(
      programs_directory?+
      ProgramInformation.new.return_name_and_version(@arguments.to_s.my_cap).join('/')
      )
      end
      end
# ===================================================================== #
# Now we can simply extract it
# ===================================================================== #
      opnef 'Now installing: '; cii target_location
      extracter = Extracter.new(target_location)
      extracter.extract_to(CONFIG.packages_dir)
      end
      end
--------------------------------------------------------------------------------
(16) → rbt glib --use-this-version=2.72.3
      But this was quite verbose.
      For RBT::Installer, the above syntax will work (eventually),
      but you can also use the @ syntax (which already does
      work) like this:
      installer glib@2.72.3
      So this will infer the version after the @ part.
      This is quite convenient and shorter to type than the
      old variant.
      ^^^^^^ whjen this option is re-enabled, simply change it
      towards glib@2.73.2 in this case.
# ========================================================================= #
# === handle_binary_installation
#
# This method handles binary installation of packages (in $PKG_DIR, which
# is normally /Depot/Packages.
# ========================================================================= #
      def handle_binary_installation(input)
# first, get all installable packages.
      @installable_packages = get_file_listing(@pkg_dir, true)
      _ = ProgramInformation.new input
      this_version = _.version
      this_program = _.name
      @installable_packages.reject! {|member| member !~ /#{this_program}/ }
# At this point we should only have programs that contain the name of the
# application the user wants to install, ie. all fox packages.
# Here you can feedback them if you want. Simply uncomment the following:
#   @installable_packages.each_with_index {  |tmp,index| e " #{index} → #{tmp}" }
      hash = {}
      @installable_packages.each { |tmp|
# make a new tmp hash
      _ = tmp.basename.gsub(/.tar.bz2$/,'')
      _ = _.gsub(/-paco/,'')
      _ = ProgramInformation.return_name(_)
      _ = _.downcase unless _.nil?
      hash[_] = tmp
      }
      @installable_packages.reject! {|member| member !~ /#{this_version}/ }
      if @installable_packages.size == 1
      do_real_install(@installable_packages.flatten[0])
      else
      e "Package: #{input} not found at #{@pkg_dir}."
      end
      end
      end; end
      if __FILE__ == $PROGRAM_NAME
      raise 'Please supply one argument to InstallPackage.' if ARGV[0].nil?
      RBT::InstallPackage.new(ARGV)
      end
# === initialize.rb
      def initialize(
      compile_these_programs = DEFAULT_PROGRAM,
      run_already            = true
      )
# ======================================================================= #
# Next, we must filter away '--' commandline arguments.
# ======================================================================= #
      compile_these_programs = filter_away_commandline_options(compile_these_programs)
# ======================================================================= #
# Next, handle blocks. This comes late here so that user-supplied
# options can overrule the prior settings, if applicable.
# ======================================================================= #
      if block_given?
      yielded = yield
# ========================================================================= #
# === initialize_dataset_for_this_program
#
# Use this method in order to initialize the main dataset for the
# given program at hand. This will only work if the program at
# hand is registered, as part of the Cookbooks project.
# ========================================================================= #
      def initialize_dataset_for_this_program(
      this_program                          = program_name?,
      check_whether_the_program_is_included = true
      )
      case check_whether_the_program_is_included
      when :bypass_check
      check_whether_the_program_is_included = false
      end
# ======================================================================= #
# First, set two default values.
# ======================================================================= #
      @extracted_directory = temp_dir?
# ======================================================================= #
# By default, we have to check whether the program is included. But
# sometimes, we may want to specifically NOT check, such as when we
# load up data from a GoboLinux recipe.
# ======================================================================= #
      can_we_continue = true
      if check_whether_the_program_is_included
      can_we_continue = RBT.include_this_program?(this_program)
      end
      if can_we_continue
# ===================================================================== #
# Also set the following variable. This can only work when @dataset
# was properly initialized.
# ===================================================================== #
      @extracted_directory = temp_dir?+dataset?.program_name?
      if @internal_hash[:configure_base_directory].nil?
      set_configure_base_dir(
      dataset?.configure_base_dir?
      )
      end
      end if this_program
      end
# === rbt/compile/do_compile_this_program.rb
      require 'rbt/toplevel_methods/last_prefix_used.rb'
      module RBT
      class Compile < Base
      def do_compile_this_program(
      )
      consider_making_use_of_cookbook_aliases # <- Re-enable cookbook aliases again here.
      ensure_that_we_can_extract_to_a_proper_directory
# ^^^ hmmm.
# ======================================================================= #
# Next, we must ensure that the extracted directory exists.
# ======================================================================= #
      _ = extract_to?+dataset_program_name_and_program_version?
      if has_to_be_compiled?
      unless File.directory? _
      opne 'No directory exists at `'+sdir(_)+'`. Has '\
      'the archive been'
      opne 'properly extracted?'
      we_can_not_continue
      return
      end
      end
      if can_we_continue?
# ===================================================================== #
# We must cd into the right directory.
# ===================================================================== #
# target_dir = TEMP_DIR+program_name_and_program_version
# ===================================================================== #
      set_configure_base_directory
      opnn; cd configure_base_directory?
# ===================================================================== #
# === Handle meson next, but only if the directory does NOT
#     have the files 'configure' and 'configure.ac'
# ===================================================================== #
      if required_deps?.include?('meson') and !
      (File.exist?('configure') and
      File.exist?('configure.ac'))
      do_use_meson_and_ninja
# ===================================================================== #
# Some programs use a fake "configure" file that uses meson. Fpr
# these cases, we will enable python3.
# ===================================================================== #
      elsif is_meson_build_type? and configure_script?
      do_use_python3
      end
# ===================================================================== #
# Handle meson-builds early on. Meson is a fairly new build system
# which depends on python3, so we enable python3 in this case.
# ===================================================================== #
# ===================================================================== #
# === Handle meson-build files even if they are not explicitely
#     listed in the required deps.
# ===================================================================== #
      if is_meson_build_type? and
      !configure_script? and
      !cmake_file? and
      !scons_file? and
      !make_file? and
      !waf_file?
      opne 'No configure script was found, also no scons, cmake or waf.'
      opne 'But we assume this program is using meson, so we will'
      opne 'switch to use '+sfancy('meson')+' and '+sfancy('ninja')+'.'
      e
      unless required_deps?.include? 'meson'
      opne 'It is recommended to add the meson-dependency '\
      'to the .yml file'
      e
      end
      do_use_meson_and_ninja
      end
#   preinstall-actions came
# and then
#   register_that_this_program_is_currently-Being_compiedl
# ===================================================================== #
# The file check on 'configure' is because some programs, such as
# pango, may come with a meson-file and an oldschool configure file.
# ===================================================================== #
      if uses_meson? and !File.exist?('configure')
      @build_directory.cd { :ensure_that_the_directory_exists }
      end
      if dependencies.include?('ruby') and File.exist?('setup.rb') and
      !File.exist?('configure')
      run_ruby_installation
# ===================================================================== #
# === Handle python-based installations, based on the setup.py file
# ===================================================================== #
      elsif do_the_dependencies_include_this_program?('python') and
      File.exist?('setup.py')
      run_python_installation
      do_not_run_make
# ===================================================================== #
# === Handle python-based installations, based on the setup.py file
# ===================================================================== #
      elsif do_the_dependencies_include_this_program?('python') and
      File.exist?('configure.py')
      run_python_installation('configure.py')
      do_not_invoke_configure
# ===================================================================== #
# === Handle scons
# ===================================================================== #
      elsif do_the_dependencies_include_this_program? 'scons'
      run_scons     # === The scons-path.
# =================================================================== #
# We will feedback the cflags value to the user, if they were set.
# Nope - we already did so prior to that.
# =================================================================== #
# ===================================================================== #
# === Handle meson/ninja
# ===================================================================== #
      elsif do_the_dependencies_include_this_program? 'meson'
      run_configure_via_system
      @build_directory.cd { :ensure_that_the_directory_exists }
      run_ninja
      else # === Oldschool configure path (configure tag)
# =================================================================== #
# We will feedback the cflags value to the user, if they were set.
# =================================================================== #
# =================================================================== #
# === The configure-path. Will be the most important one.
#
# Most programs will probably go down that path.
#
# Run GNU configure next.
# =================================================================== #
      run_configure_via_system # (configure tag)
      end
      check_for_problems_again
# ===================================================================== #
# Continue only if we may continue past the configure stage.
# ===================================================================== #
      if continue_after_configure_step?
      run_premake_make_then_make_install
      end
      check_for_problems_again # Must check again for problems, due to the above line.
      run_all_actions_after_the_make_install_step # <-- This also invokes postinstall.
      end
      consider_changing_the_tab_title '_' # Set it to an empty shell again here.
      end; alias compile_this_program_again do_compile_this_program # === compile_this_program_again
      end; end
# === depot_information_generator.rb
# ======================================================================= #
# Whats the purpose of this file? We want to write the .html
# file that does list what the directories are.
#
# To generate a new DepotStructure.html, run:
#   do_aptenix_html
# ======================================================================= #
      class HtmlInformationGenerator
      def initialize
      reset
      sanitize
      end
      def reset
      @title_of_page = 'Information about the /Depot Entries.'
      @target_file = SYS_INFO+'/DepotStructure.html'
      @directory_description = {}
      end
# ======================================================================= #
# === sanitize
# makes our info right. Is invoked for every
# new instance. Please sort alphabetically.
# ======================================================================= #
      def sanitize
      @directory_description['Audio'] = 'If you want to store '+
      'Audio stuff, do it here.'
      @directory_description['DVD'] = 'Here you can vobcopy a '+
      'DVD for example, or prepare to create a DVD.'
      @directory_description['Downloads'] = 'Quite obviously, '+
      'this is where you can download stuff from the WWW.'
      @directory_description['Information'] = 'This is to store your '+
      'non-System Information Files. System Information files will '+
      'go into ' +SYS_INFO+'.'
      @directory_description['Images'] = 'Used to store '+
      'images from the www.'
      @directory_description['IRC'] = 'Here you can store stuff from IRC '+
      'such as IRC logs. '
      @directory_description['ISOs'] = 'Quite obviously, here you '+
      'can put .iso files. '
      @directory_description['Kernel'] = 'This is for stuff such as '+
      'storing Kernel config, or images. It may be useful to '+
      'copy your self-compiled Kernel to this place, so you can reuse it '+
      'easier.'
      @directory_description['Modules'] = 'This is to '+
      'put modules inside, such as the SLAX modules. It may be '+
      'useful for you to have.'
      @directory_description['Pipes'] = 'A special dir '+
      'which might disappear soon again. Its reasoning '+
      'is that you will want to use it to pipe data '+
      'quickly.'
      @directory_description['Remastering'] = 'If you want '+
      'to remaster Aptenix for example, this is the right place.'
      @directory_description['SharedFolder'] = 'Use this if '+
      'you want to share data with others.'
      @directory_description['Torrents'] = 'This is to store your '+
      'torrent files.'
      @directory_description['Videos'] = 'This is to store your '+
      'videos.'
      @directory_description = @directory_description.sort
#
      attr_reader :hash_yaml_file_data       # Contains the dataset of our sanitized yaml file.
      attr_reader :hash_unique_abbreviations # Keeps all unique abbrevs in hash form
      attr_reader :dependencies
      attr_reader :alias_shower
      attr_reader :sanitized_data            # the sanitized data object
      alias_method :_, :sanitized_data
# ========================================================================= #
# === set_default_variables
#
# Here store ONLY variables which can change after initializing our
# dataset.
# ========================================================================= #
      def set_default_variables
      @alias_shower = AliasShower.new # This will store our aliases.
      @temp_hash = {}  # needed for chained_dependencies
      end
# ========================================================================= #
# === initialize_dataset
#
# This method is always invoked upon startup. If you want to reset your
# database object, use the aliased name `reset` instead. Normally you wont
# need to do this though. The call to the method `load_yaml_file is
# mandatory` here for EVERY startup, but needs to happen only once.
# ========================================================================= #
      def initialize_dataset(use_this_cookbook_directory = CONFIG.cookbook_directory)
      set_default_variables
      load_yaml_file(use_this_cookbook_directory)
      end; alias_method :reset, :initialize_dataset
# ========================================================================= #
# === sanitize_dataset                                       (tag aliases)
# Here we sanitize our yaml dataset.
# This method applies several changes to make the information we have,
# become sanitized - i.e. corrected. This is a rather important step, and
# mostly applies to @extract_to, as well as using a hash stored in
# RBT_Base.rb which expands certain commands. It has to be invoked only ONCE.
# ========================================================================= #
      def sanitize_dataset
# The following is only rarely needed, for modular Xorg, thus for
# version 7.1 and so on.
      @compile_modular_xorg_into_this_prefix = CONFIG.compile_modular_xorg_into_this_prefix
      end
# ========================================================================= #
# === sanitize_input_name
#
# We must sanitize our input data. This method will downcase the input
# properly, check for ',' in the string, replace ++ with 'plusplus' etc.
# This can NOT be bypassed! This method sets the variable
# @seek_this_program.
# ========================================================================= #
      def sanitize_input_name(input)
      set_seek_this_program(input)
      if @seek_this_program.is_a? Array
      warn_and_exit ' => We exit now because we were told to do so.' if @seek_this_program[0].nil?
      @seek_this_program = @seek_this_program[0] # fetch first entry from our array
      end
      end
# ========================================================================= #
# === set_program
#
# Invoke this _only_ IF a program can be found. (It will be invoked from
# Query.rb, and not from here) Pass the name of the program as its
# input. This is _MANDATORY_ - this method will then do the rest for you.
# Before we can set a new entry though, we MUST delete the old info.
# ========================================================================= #
      def set_program(this_program)
      set_default_variables
      sanitize_input_name(this_program)
      @sought_program = this_program.downcase.delete('-')
      @alias_shower.set_main_alias(@sought_program)
      _ = @alias_shower.program?
      if _.nil?
      _ = DEFAULT_PROGRAM
      _ = 'lib'+this_program if @hash_yaml_data.keys.include?('lib'+this_program)
      @sought_program = _
      end
      @pointer_to_yaml_file = @hash_yaml_data[_]
      @pointer_to_yaml_file = @pointer_to_yaml_file.inject { |base, attributes|
      warn_and_exit @sought_program+' is not included.'
      warn @sought_program+' is not included.'
# ========================================================================= #
# === traverse_hash
# Special method that will count down from max value = @highest_entry. If
# its for example 12, we make a final hash. This hash has keys down from
# "12" to "1". Each of these keys points to an array, which is populated.
# ========================================================================= #
      def traverse_hash(max_value = @highest_entry)
      e ' => Traversing our hash @dependency_frequency_hash'
      1.upto(max_value) { |val| @hash_final_build_order[val.to_s] = [] }
      @dependency_frequency_hash.each { |key, content|
# hash final build order is not so much in real use hmm.
      @hash_final_build_order[content.to_s] << key.to_s
      }
# wir müssen eventuell leere einträge löschen
      @hash_final_build_order.each { |key, content|
      @hash_final_build_order.delete(key) if content.empty?
      }
      end
# ========================================================================= #
# === graphviz_create_image
#
# Create a graphviz image by invoking RGraphvizWrapper.rb
# ========================================================================= #
      def graphviz_create_image
      opne 'Creating graphviz image next:'
      begin
      require 'graphviz'
      rescue LoadError => error
      opn
      warn_and_exit "Graphviz was not installed. Please install it. (#{error})"
      end
      collect_dependencies
      _ = GraphvizWrapper.new(@dependencies).create_image
      end
# ========================================================================= #
# === create_dependency_tree
#
# This method here will actually create the dependency tree by using the
# info from @dependencies and some additional arrays.
# ========================================================================= #
      def create_dependency_tree
      opne ' => Creating dependency tree next.'
      @dependency_bottom = []
      @dependency_top    = []
      @dependency_array_intermediate = []
      @dependencies.each { |key, content|
      @dependency_bottom << content
      @dependency_top << key
      }
# For the moment we wont need the following, thus I uncommented it
#   report_dependency_bottom
#   report_dependency_top
#   report_dependency_frequency
# ======================================================================= #
# We have to be clear that entries can have multiple references for any
# given program, so it is also more likely that this program should be
# compiled earlier than others.
# ======================================================================= #
      @highest_entry = @dependency_frequency_hash.values.max
# ========================================================================= #
# === marshal_save
#
# Use this method to save the data into a Marshal format. What data and
# why???
# ========================================================================= #
      def marshal_save
      _ = CONFIG.marshal_file
      opn; cii ' => Marshalling into '+_
      io_handle = File.new(_, 'w') # write only.
      Marshal.dump(self, io_handle).close
# ========================================================================= #
# === marshal_load
# Use this method to load data which was stored by .marshal_save().
# Usage example:
#  x = Marshal.load File.read('/System/Information/yaml_marshal_data')
# ========================================================================= #
      def marshal_load
      opn
      e ' => Loading Marshal data from '+CONFIG.marshal_file
      io_handle = File.new(CONFIG.marshal_file,'w') # write only.
      dumped_data = Marshal.load File.read(CONFIG.marshal_file)
      e dumped_data.class
# ========================================================================= #
# === report_dependency_bottom
#
# Simple Reporter about the bottom array.
# ========================================================================= #
      def report_dependency_bottom
      cliner
      e ' => These entries form the bottom of our tree:'
      cliner
      @dependency_bottom.each_with_index { |tmp, index| e "#{index} #{tmp}" }
# ========================================================================= #
# === report_dependency_top
#
# Simple Reporter about the top array. Not sure if this is here to stay.
# ========================================================================= #
      def report_dependency_top
      cliner { e ' => These entries form the top of our tree:' }
      @dependency_top.each_with_index { |tmp, index| e "#{index} #{tmp}" }
# ========================================================================= #
# === report_dependencies
#
# This shall only be invoked AFTER
#
#   collect_dependencies
#
# finished its job (it filled up the hash which we will use here).
# rloader gcc
# ========================================================================= #
      def report_dependencies
      opn
      e ' => Reporting dependencies of all our programs next.'
      @dependencies.each { |k, c| cii "*) #{'%-17s' % k} depends on #{'%+52s' % c}"}
# ========================================================================= #
# === daemonize
# This will daemonize the script, so you can query the background data.
# Yes, the Accessor Object itself can put itself into the background, this
# is a feature, not a bug ;-)
# RYamlNewSourceMaker can however also invoke this method here.
#   x = CookbookLoader.new(); x.daemonize
# localhost:8001
# ========================================================================= #
      def daemonize
      opne '=> Becoming daemon now.' # Become a daemon.
      server_object = DistributedInfrastructure.new
      _ = CONFIG.drb_port_number.to_s
      DRb.start_service(
      'druby://localhost:'+_, server_object
      )
      cii 'localhost:'+_
      DRb.thread.join
# ========================================================================= #
# === collect_dependencies
# The Dependency Walker. (Graph Drawer, draw graph)
# ========================================================================= #
# - If invoked, it will collect dependencies of important programs. Should
# not be difficult todo because required_deps_on is a needed setting in
# the yaml file already. Also, it fills up our @dependency_frequency_hash
# which stores how many times a certain dependency is referenced. Finally,
# graphviz will make an Image from this. However, Image Creation is not
# part of this method. This method only collects the needed information to
# draw a graph. Reason for the existance of this method is that I want to
# know what I must compile, in order to reach a program foobar. This method
# also creates the file:
#   /System/Information/Dependencies.html
# ========================================================================= #
# Usage example to draw a graph:
#   rload gcc
#   rload python
# ========================================================================= #
      def collect_dependencies
      e ' => Now collecting dependencies'
# Löschen vom Informations File, aka
#   /System/Information/Dependencies.html
      remove_file FILE_HTML_DEPENDENCIES
# Add Info: File created from CookbookLoader.rb
      @logger.log_file = FILE_HTML_DEPENDENCIES
      @logger.append(' = File created from CookbookLoader.rb')
      @array_available_programs.each do |program_name|
      array = @hash_yaml_data[program_name]
      array.each do |array_entry|
      array_entry.each do |k, v|
# Zur zeit wird leider nur jedes programm gelistet, das einen Eintrag
# zu required_deps_on hat. Leere Einträge werden ignoriert...
# Das is suboptimal und sollte irgendwann wahrscheinlich
# einmal geändert werden ... :(
      if k == 'required_deps_on'
      unless v.nil?
# First, remove blanks in our string.
      v.delete! ' ' if v.include? ' '
# Second, set it to this new hash.
# Example:
#   @dependencies[inkscape]=xml-parser,libgc,gtmm2,glibmm,glib,gdkmm
      @dependencies[program_name] = v
      @logger.log_file = FILE_HTML_DEPENDENCIES
      @logger.append("To Compile <b>#{program_name}</b> "+
      "you will need: <b>#{v}</b><br>")
# freq[wort] += 1
# puts "Program name war #{program_name} => #{v}"
# Third, count up the word frequency of the required_deps_on:
      if v.include? ','
      v.split(',').each { |v_tmp| @dependency_frequency_hash[v_tmp] += 1 }
      else
      @dependency_frequency_hash[v] += 1
      end
# ======================================================================= #
# At this point we did finish to build our dependency hash.
# An example look of a typical entry comes next:
#   "diva"=>
#     "mono,gtk,cairo,gtk-sharp,scons,gstreamer,gst-plugins-base,gst-plugins-good,gst-ffmpeg"
# ======================================================================= #
      end
# ========================================================================= #
# === feedback_chained_programs
# Shows interlinked/chained programs
# ========================================================================= #
      def feedback_chained_programs
      opn; cii '=>   '+@hash_chained_programs
      end
# ========================================================================= #
# === feedback_traditional_info
# Shows whether we have a traditional package or a GoboLinux like
# one using a different --prefix=/
# ========================================================================= #
      def feedback_traditional_info
      opn; cif '  => Will we use traditional approach to install program?'
      cii verbose_truth(@data.traditional)
      end
      if __FILE__ == $PROGRAM_NAME
      database_loader = DatabaseLoader.new
# database_loader.graphviz_create_image
# database_loader.marshal_load # load it again
      database_loader.set_program 'php'
# database_loader._.set_program_location('/Users/x/SRC/')
      database_loader._.set_program_location('/Depot/jjj/')
      pp database_loader.array_available_programs.join(', ')
      puts '  '+database_loader._.class.to_s+':'
      pp database_loader._.program_path
# database_loader.marshal_save
# database_loader.daemonize
      end # dload
# === compile.rb
      DEPRECATED
# =========================================================================== #
# === RBT::Compile
#
# Optionally, the specific version that should be compiled, can
# also be passed in.
#
# Other ways to install a given program are also possible, such
# as by using cmake, scons, meson, waf or clang, or by installing
# ruby gems, perl cpan modules or python eggs. The support for
# these installation modes differs in quality though - most time
# was spent for the default GNU configure/make/make install runs,
# as these appear to cover most available programs.
# =========================================================================== #
# =========================================================================== #
# Next require all rbt/compile/ specific .rb files.
# =========================================================================== #
# =========================================================================== #
# Next, .rb files residing under "rbt/misc".
# =========================================================================== #
      require 'rbt/misc/build_detector.rb'
      ^^^ do we have this? I think so.
# =========================================================================== #
# Require important rbt/toplevel_methods/ files next.
# =========================================================================== #
      require 'rbt/toplevel_methods/check_for_binary_duplicates.rb'
# =========================================================================== #
# Next, fail-safe require of cookbooks-related .rb files. These must be
# rescued because the cookbooks project is optional.
# =========================================================================== #
      require 'rbt/utility_scripts/create_new_cookbook.rb'
      require 'rbt/requires/require_the_cookbook_class.rb'
      module RBT
      class Compile < Base # === RBT::Compile
# ========================================================================= #
# === continue_after_make_step?
# ========================================================================= #
      def continue_after_configure_step?
      @continue_after_configure_step
      end; alias continue_after_make_step?       continue_after_configure_step? # === continue_after_make_step?
      alias continue_after_configure_phase? continue_after_configure_step? # === continue_after_configure_phase?
# ========================================================================= #
# === do_not_continue_and_do_not_compile
# ========================================================================= #
      def do_not_continue_and_do_not_compile(be_verbose = :be_verbose)
      do_not_continue(be_verbose)
      do_not_compile(be_verbose)
      end
# ========================================================================= #
# === run_all_actions_after_the_make_install_step
#
# This method bundles together the typical steps after "make install".
#
# Note that these methods can also be run for non-make install programs,
# it really is a general post-make-install step.
# ========================================================================= #
      def run_all_actions_after_the_make_install_step
# ======================================================================= #
# Save dataset into the "compiled_programs.yml" file.
# ======================================================================= #
      save_into_compiled_programs
# ======================================================================= #
# Next, de-register from the status file again.
# ======================================================================= #
      deregistering_from_the_status_file
      consider_uploading_binaries
      if !can_we_continue?
      notify_the_user_that_something_failed_at_configure_stage
      end
# ======================================================================= #
# Next, perform some postinstall actions. This also includes
# running cleanup-actions or installing glib-schema files.
# ======================================================================= #
      consider_performing_postinstall_actions
# ======================================================================= #
# Next, go to the log directory, before potentially removing the
# extracted directory. If we are verbose then we should also
# use opnn.
# ======================================================================= #
      cd :log_directory, :be_quiet # Silent cd.
      end
      module RBT
      class Compile < Base
# ========================================================================= #
# === reset
# ========================================================================= #
      def reset
      set_configure_base_directory # Initialize to nil here.
      @may_we_exit = true          # if we may exit or not.
# set_compile_these_programs # Defaults to nil initially. Uncommented Sep 2012 as the run() method also invokes it.
      @run_configure_script = true # If true, we run a configure script. Defaults to true.
      @may_we_run_make_install_command = true # if true then we will run the make install command
      @continue_after_make_step = true
      end
# ========================================================================= #
# === enable_use_clang_as_compiler
#
# Not yet finished, as it needs to be tested.
# ========================================================================= #
      def enable_use_clang_as_compiler
      ^^^ hmmmmmmmmmmmmmmmmm
# ======================================================================= #
# === Here we can check for available versions. (All versions,
#                                                version tag, v tag,
#                                                v1 tag)
# You can also give negative numbers:
#   ry grep v1
#   ry grep v2
#   ry glib v3
#   ry perl v-3
#   ry htop v-1
# ======================================================================= #
      when /^v-?(\d)+$/, /^(\d)+$/,'last','first','check_and_set_version',
      'vlatest','vnewest'
      check_and_set_version(_)
# ======================================================================= #
# === Generate debian package (DEB TAG DEBIAN TAG)
#
# If you want to create a debian package, use this method.
#
# ry php5 cdeb
# ======================================================================= #
      when 'todeb','2dep','create_debs','cdeb',
      'cdebs','cdep','deb'
      create_debian_package
# ========================================================================= #
# === check_for_library
#
# Use this method to check for libraries.
#
# Usage example:
#   ry htop check_for_library
# ========================================================================= #
      def check_for_library(i = nil)
      opnn
      e 'Checking for all library-names called `'+
      @compile_these_programs.to_s+'` next:'
# Now, get the libraries. Not sure if this is finished or not hmm.
      pp libraries?
      exit_program
      end
# ======================================================================= #
# === consider_using_stow
#
# Since Mar 2011 we also invoke stow here, if the configuration
# option was set.
# ======================================================================= #
      def consider_using_stow
      if use_stow?
      unless program_exists? 'stow'
      warn 'Program '+sfancy('`stow`')+' does not seem to be installed.'
      warn 'Please install it first.'
      exit_program
      else
      stow_directory = DEPOT_DIR+'/Information/stow'
      _ = 'stow --verbose --target=/ --dir='+stow_directory+' '+@_
      esystem(_)
      end
      end
      end
# ========================================================================= #
# === do_chained_compiling
#
# Use this method to do chained compiling.
# ========================================================================= #
      def do_chained_compiling(i = @_)
      require 'rbt/chained_compiling.rb' # Hmm. Requiring this leads to problems.
      ChainedCompiling.new(i)
      end
# ========================================================================= #
# === check_whether_all_cookbook_entries_are_valid
# ========================================================================= #
      def check_whether_all_cookbook_entries_are_valid
      if exit_on_unregistered_cookbook_entries?
      unless @cookbooks.program_dataset.array_invalid_keys.empty?
      output_namespace?; e 'We found at least one invalid entry in our cookbooks.'
      @cookbooks.program_dataset.report_invalid_cookbook_entries
      output_namespace?; e 'We will exit the compilation process now as the option'
      output_namespace?; e sfancy('exit_on_unregistered_cookbook_entries')+' was set.'
      exit
      end
      end
      end
# ========================================================================= #
# === check_how_often_we_invoked_traditional_or_non_traditional_compilation
#
# This method may show a notification to the user, about conflicting
# intents in regards to the prefix.
# ========================================================================= #
      def check_how_often_we_invoked_traditional_or_non_traditional_compilation
      if ihash?[:counter_called_traditional_or_non_traditional_compilation] > 1
      output_namespace?
      e 'Warning - you seem to have conflicting values for traditional'
      output_namespace?
      e 'and non-traditional invocations.'
      output_namespace?
      e 'Currently the RBT scripts will favour the last specified'
      output_namespace?
      e 'setting. Thus, only the last value for prefix will be honoured.'
      end
      end
# ========================================================================= #
# === do_compile_these_programs
#
# This large method is the actual action to compile a given program.
# It expects a String as input, which must hold which programs we
# wish to compile.
# ========================================================================= #
      def do_compile_these_programs(i = program?)
# ======================================================================= #
# We next check whether the user passed us both 'trad' and 'non_trad'
# at the same time.
# ======================================================================= #
      check_how_often_we_invoked_traditional_or_non_traditional_compilation
      _ = program_path? # must reassign again because of the next method.
# ======================================================================= #
# Check whether we compile via scons.
# ======================================================================= #
      if deps_on?.include? 'scons'
      compile_via_scons
      else # Else use GNU autoconfigure.
      invoke_gnu_autoconfigure
      end
      consider_using_stow
# here used to be ldconfig.
      report_finished_installing_this_program(compile_this_program?)
# And then remove the archive again - this has already happened.
      end
# ========================================================================= #
# === invoke_gnu_autoconfigure           (autoconfigure tag, configure tag)
#
# ========================================================================= #
      def invoke_gnu_autoconfigure
      if @prefix.prefix?.to_s.include? programs_directory?
# ===================================================================== #
# Next, we will try to generate the Dependencies file if we are on a
# Gobolinux-like system.
# ===================================================================== #
      if ENV['GOBOLINUX_LAYOUT'].to_i == 1
      prefix_to_use = @prefix.prefix?
# _ << prefix_to_use
      create_dependencies_file(prefix_to_use)
      create_description_file(prefix_to_use)
# ======================================================================= #
# Next check if we have to run a configure script or not.
# ======================================================================= #
      if run_configure_script?
# ===================================================================== #
# We store the configure command in the base dir, but only
# when we are really in that base directory.
# ===================================================================== #
      store_here = Dir.pwd+'/CONFIGURE_COMMAND.md'
      remove(store_here) if File.exist? store_here
      output_namespace?
      e 'We will store the following configure options '+
      'into the file `'+sfile(store_here)+'`'
      save_file(_, store_here, '755')
      configure_file = configure_command?
# ===================================================================== #
# We must check if the configure file actually exists or not next.
# ===================================================================== #
      if File.exist?(configure_file) or ! configure_command?.include?('configure')
      esystem(_)
      else # Else we check for it, but only if we actually use the configure command.
# ===================================================================== #
# Now, perhaps there is an autogen.sh file
# ===================================================================== #
      if File.exist? configure_base_directory?+AUTOGEN
      output_namespace?; e 'We found an '+AUTOGEN+' file. We will '+
      'invoke it now.'
      do_use_autogen
      esystem(_)
      else
      output_namespace?; e '`'+sfile(configure_file)+'` does not seem '+
      'to exist in `'+sdir(rds(Dir.pwd+'/'))+'`.'
      output_namespace?; e 'Thus we will skip trying to run the '+
      '`'+simp(configure_command?)+'` command.'
      end
      end
# ===================================================================== #
# Intercept here when @continue_after_configure_phase is false.
# ===================================================================== #
      exit_program unless continue_after_configure_phase?
# run_premake_make_then_make_install <--- already integrated.
      end
      end
# ========================================================================= #
# === run_make_install_command                           (make install tag)
#
# This will run the "make install" command basically.
# Some programs such as xfsprogs.yml require a slightly different
# "make install" command.
# ========================================================================= #
      def run_make_install_command
      if continue_after_make_step?
      if @may_we_run_make_install_command
      if run_simulation?
      output_namespace?
      e 'We are running in simulation mode, hence the following command '
      output_namespace?
      e "won't be run:"
      output_namespace?
      efancy '  '+cmd
      else # Else, run it.
      _ = rds(
      configure_base_directory?+
      use_this_build_directory?+
      '/Makefile'
      )
#   warn 'File `'+sfile(_)+'` was not found, thus '
#   warn 'not running `'+sfancy(cmd)+'`.'
#   @continue_after_configure_phase = false
# end
# ========================================================================= #
# === set_compile_these_programs
# ========================================================================= #
      def set_compile_these_programs(i = DEFAULT_PROGRAM)
      i.map! {|entry|
# ===================================================================== #
# Now we have two possibilities:
#   The file exists. In that case, we take that file and
#       continue working with it.
#   (2) The file does not exist. In that case we assume that
#       the user wants to work from the cookbooks.
# ===================================================================== #
      if File.exist? entry
      else
      entry = entry.dup
      case entry # case tag
      when 'REPEAT'
      entry = last_compiled_program? unless last_compiled_program?.nil?
      end
      entry = entry.downcase # Careful - after this point, we keep it downcased.
# =================================================================== #
# === Act on special syntax
#
# Act on special syntax next, leading @ or : entries.
# @ is no longer possible here, but perhaps :
# such as:
#       ry :glib
# ^^^^^^^^^^^^^
# but what does it mean? hmmmmmmm. Did I store this somewhere?
# Evidently the code below means that it refers to "last_compiled_program?"
# but ... no wait... this ONLY handles:
#
#   ry :last
#    ^^^^^^^ so re-enable this. Yeah do so!
# =================================================================== #
      case entry[0,1] # case tag
      when '@',':'
      entry[0,1] = ''
      case entry
      when 'last','las','la','l','LAST'
      entry = last_compiled_program?
# ^^^ this is, I think, useful. Need to -recheck it if we can
#     re-use this again.
# ===================================================================== #
# The program to compile is stored here in this variable for easier
# access. It is an alias towards @compile_these_programs.
# ===================================================================== #
      case entry # case tag
# ===================================================================== #
# === all
# ===================================================================== #
      when 'all'
      if match
      entry = return_chained_programs[match].split(',').map(&:strip)
      @commandline_arguments[0] = nil # Remove the argument then.
      e 'You want to compile all programs that somehow include '+
      'the keyword "'+simp(keyword)+'".'
      e 'We list these now in alphabetical order:'
      pp match
      e 'We will sleep for '+sfancy(5)+' seconds so that '+
      'you can check, and possibly interrupt,'
      e 'before we continue.'
      sleep 5
      end
      end
      end
      entry
      }
      @_ = @compile_these_programs = i
      end; alias set_compile_this_program set_compile_these_programs # === set_compile_this_program
# ========================================================================= #
# === check_whether_to_use_a_build_directory
#
# Use this method to check whether we will use a build directory or not.
# ========================================================================= #
      def check_whether_to_use_a_build_directory
      use_this_build_directory = DEFAULT_NAME_BUILD_DIRECTORY # local variable.
      use_this_build_directory << '/' unless use_this_build_directory.end_with? '/'
      if use_build_directory?
      output_namespace?
      e 'We will use a build directory, called '+sdir(use_this_build_directory)+'.'
      unless use_this_build_directory?.empty?
      use_this_build_directory = use_this_build_directory?
      end
      mkdir(use_this_build_directory)
# And we must switch to it too, of course.
      cd Dir.pwd+'/'+use_this_build_directory
      @configure_prefix.prepend '.'
      sanitize_build_directory
      end
# ========================================================================= #
# === check_and_set_version
#
# A wrapper around the class CheckForAvailableVersions.
#
# The only argument it accepts, `version_to_use`, is the version we
# wish to use.
#
# Usage example:
#
#   ry bluefish v2
#
# ========================================================================= #
      def check_and_set_version(version_to_use)
      cfav = RBT::Cookbooks::CheckForAvailableVersions.new(@_) # bl $RUBY_COOKBOOKS/lib/cookbooks/check_for_available_versions.rb
      name = cfav.position_at(version_to_use)
      output_namespace?; e 'Using `'+sfancy(name)+'` now.'
      _ = @cookbooks.data
      _.set_version(cfav.version?, true)
      _.find_correct_archive
# assign_data # Here we must sync.
      end
# ry htop --tags pdf
--------------------------------------------------------------------------------
(17) → fix:
      ry glibc ntrad dontsymlink --use-this-version=2.26
      ^^^
--------------------------------------------------------------------------------
(18) → someone on IRC: I am going to test creating valid gobolinux recipes
      with the RBT scripts.
      someone on IRC: in the long version
      rbt php generate_gobolinux_recipe
--------------------------------------------------------------------------------
(19) → Test autogeneration of gobolinux recipes.
--------------------------------------------------------------------------------
(20) → --purge-old-version
      ^^^ but only if we compile into the /Programs hierarchy and only
      if it was successful. so before this can be enabled, we need
      to have worked on "was this a success".
      ^^^ interesting.....
--------------------------------------------------------------------------------
(21) → At first make use of the ... thingy that fpm. then when we
# udnerstood it properly we can replace fpm and integrate it.
--------------------------------------------------------------------------------
(22) → When we compile this, also do a
      restore/
      directory machen, sowohl wenn prefix /usr als auch
      gobolinux prefix.
      Aus diesem restore/ dir kann man dann folgendes machen:
      make clean
      make install
      Für /usr prefix hierarchy müssen wir das ganze in:
      $HOME/.rbt/Programs
      speichern. Oder so.
      Für gobo prefix in:
      /Programs/Htop/7.5/restore/
--------------------------------------------------------------------------------
(23) → add a way to sync all CHANGED cookbooks
      so we need a way to determine when the last update
      happened hmmmmmm. What does this even mean?
--------------------------------------------------------------------------------
(24) → -b, --batch
      Batch mode: avoid asking questions.
      Apply where? Hmm. In general, probably.
--------------------------------------------------------------------------------
(25) → Automated program compilation tool.
      Usage: Compile <program> [<version>]
      Options:
      -c, --configure-options <entry>
      Options to be passed explicitly to './configure'.
      --logfile <entry>
      Log all output to a specified file.
      -n, --app-name <entry>
      Override application name.
      -x, --cross-compile <entry>
      Cross-compile to another architecture.
      -l, --symlink <entry>
      If symlinks should be created and wether they should be forced
      on conflicts.
      Valid entries are: 'yes' 'no' 'force'
      The default value is 'yes'.
      -G, --no-sign
      Do not sign program.
      -U, --no-updatesettings
      Do not update settings for the program
      -M, --no-unmanaged
      Do not install unmanaged files.
      -L, --lazy
      'Lazy mode': cut some corners when rebuilding; debugging aid:
      do NOT use it for building packages.
      -A, --start-at <entry>
      Skip sub-recipes when building a meta-recipe: start include list at
      given recipe; effective only with --lazy; debugging aid: do NOT use
      it for building packages.
      -D, --no-dependencies
      Do not try to fulfill dependencies.
      -i, --install-separately
      If the application is part of a meta recipe, do not install it into
      the containing application but install it into a separate directory.
      -R, --no-requirements
      Do not process the Requirements script after installation
--------------------------------------------------------------------------------
(26) → From Freshen, add:
      - GetRecipe in ruby
      - GetRecipes only of installed
      programs AND only if newer version, dont flush /Files/Compile/Recipes
      like Freshn does. - liste mit aktualisierbaren recipes/packages
      anzeigen
      ^^ Clone Gobolinux Functionality.
--------------------------------------------------------------------------------
(27) → integrate gobolinux loader.
      This works semi-ok ... some bugs still exist
      ALSO we must check for recipe-type still.
      but aside from this, this should be doable.
      we could also use this to load a gobo recipe :)
--------------------------------------------------------------------------------
(28) → enable:
      set_configure_base_dir
--------------------------------------------------------------------------------
(29) → Hmmm. Wenn wir "Compile bla" machen dann sollten wir auch eine
      yaml datei erstellen, die ALL die relevante Information hat.
      So können wir nämlich copy/pasten ...
      Also wahrscheinlich noch eine Yaml Datei erstellen.
      all_information.yml
      oder so.
      Ich check das nicht ganz ... copy/paste wozu?
      Aber die Idee mit der yaml datei, die ... wichtige informationen
      behlt ist nit so schlecht...
      aber zuerst mal sollten wir das "compiled program" überlegen b
      ob success war oder nit
--------------------------------------------------------------------------------
(30) → add:
      --enable-everything
      ^^^ this enables all --enable and all --with
      This has been added but not yet documented.
      It is also a bit buggy and only works for --enable-related entries.
--------------------------------------------------------------------------------
(31) → enable sinatra bindings to rbt core functionality
      For example:
      install/name/version
      ^^^ version is optional
      this must work!
      query/program_version/htop
      ^^^ these as wlel.
      We added /view; we have to document this still in README.gen
      and make it a bit prettier, and add more functionality.
      ^^^^
      also find a free webhost for this and host it hmmmm.
      Heruko? HMmm.
      rbt --sinatra
      ^^^ make this work too.
      ^^^document properly as well
      Once install and query works and remove hmm
      remove this entry here.
      also add UrlAction
      ^^^ hmmm.
      Yeah we must extend UrlAction and we must add more
      HtmlTemplate instances as well.
--------------------------------------------------------------------------------
(32) → Add the ability to uninstall packages with dependencies.
      add action:
      Uninstall.new :htop
      ^^^^ this works only a bit so far e. g. we can uninstall directories
      but we also want to be able to say "uninstall libfoo.so.1"
      and this will uninstall the other files that belong to this
      package.
--------------------------------------------------------------------------------
(33) → write a script that tells us which programs are
      available in a statically compiled manner.
      Work through things such as:
      coreutils
      binutils
      and then figure out which one is static.
--------------------------------------------------------------------------------
(34) → 
      rbt: add a toplevel method that checks for the correct
      program
--------------------------------------------------------------------------------
(35) → → - enhance the GUI things from the get go, perhaps even
      via jruby. yeah.
      → - make sure it works on windows from the get go as well
      and test it!
      → - start via action DRIVE the actions forward.
      → - also when we do a GUI, make it via tabs, including for libui
      so that we have all awesome functionality in a single GUI
      really. also visually pretty; first in gtk though.
      then libui.
      and add a few screenshots too
      however had before we do so, start with slow polishing
      so that the whole RBT suite becomes better
--------------------------------------------------------------------------------
(36) → We need a way to work with SQL dataset too rather than
      .yml flatfiles. This now works a bit via RBT::CompileViaSQLDatabase.
      Needs to be improved further.
      Also read up on Sequel for this. Once we understand it, try to
      transition to using Sequel.
      ^^^ also add class
--------------------------------------------------------------------------------
(37) → add --backend=
      for rbt compile to specify sqlite, or raw-yaml,
      expanded, expanda-dataset + explain it
      One day we should be able to specify this.
      For now (2022) we let it go.
--------------------------------------------------------------------------------
(38) → we should rewrite the project. The meta-goals are:
      (1) support on windows for compilation
      ^^^ but this does not work.
      Also add more specifications in this regard.
      HOWEVER HAD before we rewrite the project,
      add all these missing things such keep_extracted: t and such
      AND then investigate how to turn this into a SQL table.
      and how to query it. So investigate SQL.
      and make this work on windows as well.
--------------------------------------------------------------------------------
(39) → allow just a single src_dir, without subdirectories
      via some configuration value or so. also an ENV
      setting and commandline.
--------------------------------------------------------------------------------
(40) → enable support for:
      rbt --compile_all_of=science
      rbt --tag_compile=science
      rbt --compile_these_tags=php
      ^^^ strangely this leads to an infinite loop right now (Sep 2017)
      ^^^^ chek agian
      ^^^ ok rewrite this ... or at the least the part that is faulty
      UNTIL THIS OWRKS
--------------------------------------------------------------------------------
(41) → tocd; cd icu4c; appdir *
      appdir *
      -rw-r--r-→ 1 root root 13M Dec 21 03:02 icu4c-60.2.tar.xz
      -rw-r--r-→ 1 root root 13M Dec 21 03:02 icu4c-61.1.tar.xz
      -rw-r--r-→ 1 root root 13M Dec 21 03:02 icu4c-62.1.tar.xz
      -rw-r--r-→ 1 root root 14M Dec 21 03:02 icu4c-63.1.tar.xz
      -rw-r--r-→ 1 root root 14M Mar 29 13:23 icu4c-64.1.tar.xz
      /Users/x/SRC/icu4c/appdir
      ^^^ enable support for this, so that we can
      batch-compile all these existing .tar.xz files
      as an appdir. hmmmm
      is this part of easycompile...
      should become part of rbt
      RBT.action(:appdir, ARGV)
      ^^^ it already is part of RBT. Already handled via actions
      so enable this and then document this!
--------------------------------------------------------------------------------
(42) → Install all the package managers on the computer system.
      ^^^ document this as well in a new subsection.
      → add a new subsection. [DONE]
      → dpkg/apt was mentioned but next is pacman.
      → rpm + dnf
--------------------------------------------------------------------------------
(43) → und permission checking for RBT.
      ^^^^ we must check this for windows, whether
      we are even allowed to create a directory
      or not.
--------------------------------------------------------------------------------
(44) → Consider adding:
      --silent
      --silence
      --quiet
      or so to show less, or something like that.
--------------------------------------------------------------------------------
(45) → Der check auf "if makefile exists"
      soll nicht gemacht werden wenn wir:
      - ruby
      - python
      - perl programme installieren
      ^^^ testen mit einem perl programm. beziehungsweise
      wenn der check is "has to be compiled".
      Weil die ham natürlich kein Makefile!!! meistens zumindest.
      ^^^ das is schon gefixed für "make install", nun
      müssen wir das auch noch für "make" fixen.
      ^^^ alos nur wenn es ein compiled-thing is.
      hmmmmmm das mach ma eh schon oder?
--------------------------------------------------------------------------------
(46) → This used to work in the past I think:
# ======================================================================= #
# === ry htop check_for_library
# ======================================================================= #
      when 'check_for_library',
      'lib',
      'libraries',
      'libs',
      'cfl'
      check_for_library
--------------------------------------------------------------------------------
(47) → FEATURE:
      enable all of FPM. Start via slackware packages:
      ry htop --create-slackware-package
      ^^^ this should work......
      ry php --create-slackware-package
--------------------------------------------------------------------------------
(48) → work on:
      --no-harm
      ^^^ equivalent to --simulate-only
      ry htop --no-harm
      ^^^
      ^^^ fowlmouth: i think thats an option for the future definitely
      We need to continue this, especially on AdvancedSymlink.
      It is not yet finished.
      Probably will take a long time...
--------------------------------------------------------------------------------
(49) → fix: trad ssh2
      ^^^ the abbreviation is shown TWICE. That means the logic is wrong.
--------------------------------------------------------------------------------
(50) → re-do RBT hmmm but select some specific things
      to improve while re-doing this.
      - fix the /home/programs/ issue.
      AND perhaps describe the components, each step...
      error messages too and what not
--------------------------------------------------------------------------------
(51) → alias gcc_11.3.0='rbt gcc --use-this-version=11.3.0 --ntrad'
      ^^^ fix this issue
      ^^^
      gcc1130
      then copy to the other computer
      and fix some opn-related problem
--------------------------------------------------------------------------------
(52) → fix "make -j" in rbt.
--------------------------------------------------------------------------------
(53) → also, once the two OLD *rb files were ported
      work through compile-menu step by step
      work it through, make sure it all works as-is.
--------------------------------------------------------------------------------
(54) → Continue to improve report for class Cookbook
      this should be used rahter than Display ... the latter
      should probably be removed altogether. hmmmmm.
      ^^^ evaluate this. No clue whether we should keep it
      or not. It is actually used in RBT::Compile.
--------------------------------------------------------------------------------
(55) → make sure that the installation_steps work? hmmmmmmmmmmmmmmmm
      and document this a bit as well once this works.
--------------------------------------------------------------------------------
(56) → add a SQL database that contains all that information as-is,
      rather than use expanded cookbook files. This should be
      faster to query on windows in particular.
--------------------------------------------------------------------------------
(57) → /System/Index/bin/ld: error: cannot find -lgtkmm-3.0
      ^^^ register such an error
      AND at the least colourize this in red, the message that is [DONE THIS PART]
      ^^^
--------------------------------------------------------------------------------
(58) → add a kill-compile-button or so
      but we must determine the PID
      ^^^ the functionality now exists but we need to
      re-arrange the button there. align it rightwards
--------------------------------------------------------------------------------
(59) → When we repackage something, and an extracted dir with the same
      name already exists, then we notify the user of that, create a
      new dir called
      /REPACKAGING/name_here/ # if that latter name exists already, delete it.
      That way we can compile the same app again.
--------------------------------------------------------------------------------
(60) →  # ======================================================================= #
# === @simple_or_complex
#
# This determines whether to sanitize the dataset (when we use :simple)
# or whether we use the expanded dataset.
#
# It must come before we initialize a new raw cookbook.
# ======================================================================= #
# TODO: This should be changed to expanded dataset; and if the file has
# changed, we expand the dataset before loading it ...
# So ultimately it should be :complex really by default. But we still
# need to add the expand-dataset part first before we can change this.
# ======================================================================= #
--------------------------------------------------------------------------------
(61) → make it possible to compile a local archive, a local
      file, even if it is not registered.
      ^^^ test this.
      if check_whether_the_given_input_is_a_file_and_does_exist? and
      does_this_file_exist_and_is_it_a_file?(this_program) # This may be the case when the user supplied a path.
      ^^^
--------------------------------------------------------------------------------
(62) → We need to get a minimal tk for ruby on windows to work.
      The idea is really to keep this super simpler.
      tk-entries + buttons.
      compile
--------------------------------------------------------------------------------
(63) → Write some class that scans config.log and similar
      files for problems automatically,  so that I no
      longer have to read these awful files manually.
      RBT::ConfigLogParser handles this.
      We probably have to improve on it.
      But how to test it? Hmmm.
--------------------------------------------------------------------------------
(64) → ry libpng --trad --cmake
      RBT::Compile: Using a "traditional" strategy for compilation (which means prefix /usr/).
      RBT::Compile: We will use cmake rather than make.
      RBT::Compile: Making use of these special environment variables:
      LIBS will be set to the value(s): -lpthread
      RBT::Compile: The program `libpng` will be compiled next.
      RBT::Compile: Removing the old directory at `/home/Temp/rbt/libpng-1.6.37/`.
      RBT→Extracter: Extracting `libpng-1.6.37.tar.xz` to `/home/Temp/rbt/` next.
      RBT→Extracter:   tar -xvf /home/x/src/libpng/libpng-1.6.37.tar.xz -C /home/Temp/rbt/
      RBT→Extracter: Finished extracting to `/home/Temp/rbt/libpng-1.6.37/`.
      ┏ Infobox ━━━━━━━━━━━━━━━━━━━━┳━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━┓
      ┃                             ┃                                                                                    ┃
      ┃ Compiling this program:     ┃ libpng                                                                             ┃
      ┃ Prefix:                     ┃ /usr/                                                                              ┃
      ┃ Program version:            ┃ 1.6.37                                                                             ┃
      ┃ Program path:               ┃ /home/x/src/libpng/libpng-1.6.37.tar.xz                                            ┃
      ┃ configure options:          ┃ --enable-shared --disable-static --with-binconfigs                                 ┃
      ┃ Will be extracted towards:  ┃ /home/Temp/rbt/libpng-1.6.37/                                                      ┃
      ┃ Keep the archive extracted: ┃ Yes.                                                                               ┃
      ┃ Will ccache be used:        ┃ Yes.                                                                               ┃
      ┃ CFLAGS in use:              ┃ -O2 -fPIC -fno-strict-overflow -Wno-error                                          ┃
      ┃ Use a build directory:      ┃ No.                                                                                ┃
      ┃ Host architecture in use    ┃ x86_64                                                                             ┃
      ┃ Build system to be used:    ┃ configure                                                                          ┃
      ┃ Compiler to be used:        ┃ gcc                                                                                ┃
      ┃ URL to the source archive:  ┃ https://sourceforge.net/projects/libpng/files/libpng16/1.6.37/libpng-1.6.37.tar.xz ┃
      ┃ Homepage:                   ┃ http://www.libpng.org/pub/png/libpng.html                                          ┃
      ┃                             ┃                                                                                    ┃
      ┗━━━━━━━━━━━━━━━━━━━━━━━━━━━━━┻━━━━━━━━
      ^^^ was stimmt da nit
      sollte cmake verwenden!!!!!
      ^^^ THIS SHOULD DISPLAY THE BUILD SYSTEM AS CMAKE.
--------------------------------------------------------------------------------
(65) → Add the ability to safely remove unneeded packages.
--------------------------------------------------------------------------------
(66) → add:
      rbt --upload-programs-version
      ^^^ enable this
--------------------------------------------------------------------------------
(67) → Finish the rewrite of the gnome-thingy.
      Or perhaps start anew there.
--------------------------------------------------------------------------------
(68) → ry php use_cookbook=/Depot/jjj
      ^^^ add the above and also add to rbtcgi page...
      this way we can use any other cookbook file. (if is directory
      then we read all into it, otherwise specifiy here.)
      dann in rbtcgi übertragen.
--------------------------------------------------------------------------------
(69) → build proper slackware packages for 64 bit
      auto-store them into /Depot/Packages/ if that
      directory exists # yup, no matter if on-roebe or
      not
      ^^^ perhaps make a standalone ruby-gtk3 stuff
      ^^^ test installing these packages though... something
      doesn't quite work yet.
      then when this is all done... look as to how
      to remaster slackware...
      ^^^ also make it possible via a GUI as well.
      and make the gui a NOTEBOOK TAB!!!
      but focus only on ruby-gtk3 really at the least
      for new code when needed.
      ^^^ and integrate the ruby-gtk code that already
      exists as-is
      CONTINUE HERE THEN AFTERWARDS
--------------------------------------------------------------------------------
(70) → add some script that checks whether
      any program has been updated or not.
      This shall replace manual update stuff.
      ^^^^ hmmm.
      that class shall show to use which programs could be updated.
--------------------------------------------------------------------------------
(71) → When the user uses --dontsymlink, then do not make a Current symlink
      doing so breaks gcc-compilation!
      ry gcc ntrad --use-this-version=6.4.0 --dont-symlink
      RBT::Compile: Setting to the specific version `6.4.0` now.
      RBT::Compile: We will not symlink after compilation has finished.
      RBT::Compile: The program `gcc` will be compiled/installed next.
      = Infobox ======================================================================
      |                               |                                              |
      | Compiling this program:       | gcc                                          |
      | Prefix:                       | /Programs/Gcc/6.4.0/                         |
      | Program version:              | 6.4.0                                        |
      | Program path:                 | /Users/x/SRC/gcc/gcc-6.4.0.tar.xz            |
      | Keep the                         |
      ================================================================================
      RBT::Compile: Removing the old directory at `/Depot/Temp/rbt/gcc-6.4.0/`.
      RBT→ Extracter: Extracting `gcc-6.4.0.tar.xz` to /Depot/Temp/rbt/ next.
      RBT→ Extracter:   tar -xvf /Users/x/SRC/gcc/gcc-6.4.0.tar.xz -C /Depot/Temp/rbt/
      RBT→ Extracter: Finished extracting to `/Depot/Temp/rbt/gcc-6.4.0/`.
      RBT::Compile: Entering the directory /Depot/Temp/rbt/gcc-6.4.0/
      RBT::Compile: Now entering the directory `/Depot/Temp/rbt/gcc-6.4.0/BUILD_DIRECTORY/`.
      RBT::CreateProgram: Gcc-6.4.0 (Program name: Gcc and Program Version: 6.4.0)
      RBT::CreateProgram: The target directory will be at `/Programs/Gcc/6.4.0/`.
      RBT::CreateProgram: Creating directory /Programs/Gcc/6.4.0/ next.
      RBT::CreateProgram: Several subdirectories will now be created in that directory, namely:
      RBT::CreateProgram:   bin/, include/, lib/, man/, sbin/, Shared/, Resources/
      RBT::CreateProgram: Done!
      RBT→ Symlink: Symlinking /Programs/Gcc/6.4.0/ into /Programs/Gcc/Current.
      ================================================================================
      CC="ccache gcc" /Depot/Temp/rbt/gcc-6.4.0/configure --prefix=/Programs/Gcc/6.4.0/ --build=x86_64-linux-gnu --host=x86_64-linux-gnu --target=x86_64-linux-gnu --enable-bootstrap --enable-__cxa_atexit --enable-checking=release --enable-clocale=gnu --enable-debug --enable-languages=c,c++,objc,fortran,go --enable-linker-build-id --enable-ld=default --enable-multiarch --enable-nls --enable-objc-gc --enable-plugin --enable-threads=posix --disable-decimal-float --disable-libgcj --disable-libgomp --disable-libmudflap --disable-libssp --disable-libstdcxx-pch --disable-libunwind-exceptions --disable-multilib --disable-werror --disable-install-libiberty --with-arch_32=i686 --with-cloog --with-cpu=generic --with-gnu-as --with-gnu-ld --with-multiarch-defaults=x86_64-linux-gnu --with-newlib --with-plugin-ld=ld --with-system-zlib --with-sysroot=/usr/include --with-tune=generic --without-headers 2>&1
      ================================================================================
      checking build system type... x86_64-pc-linux-gnu
      checking host system type... x86_64-pc-linux-gnu
      checking target system type... x86_64-pc-linux-gnu
      checking for a BSD-compatible install... /usr/bin//ginstall -c
      checking whether ln works... yes
      checking whether ln -s works... yes
      checking for a sed that does not truncate output... /usr/bin//sed
      checking for gawk... gawk
      checking for libatomic support... yes
      checking for libcilkrts support... yes
      checking for libitm support... yes
      checking for libsanitizer support... yes
      checking for libvtv support... yes
      checking for libmpx support... yes
      checking for x86_64-linux-gnu-gcc... ccache gcc
      checking for C compiler default output file name...
      configure: error: in `/Depot/Temp/rbt/gcc-6.4.0/BUILD_DIRECTORY':
      configure: error: C compiler cannot create executables
      See `config.log' for more details.
      Unregistered error: configure_error (class: Symbol)
      Unregistered error: configure_error (class: Symbol)
      RBT::Compile: The program `gcc` could not be installed.
--------------------------------------------------------------------------------
(72) → In RBT rbt, make a GUI that shows the result per line,
      into a textview widget - live, when compiling something.
      Unfortunately this does not work well when RBT::Compile
      alos makes use of IO.open() and such. We may have to
      redesign the whole project.
--------------------------------------------------------------------------------
(73) → ensure that the another program name such as GCC works.
      also add:
      use_this_program_name_on_gobolinux:
      Basic support for this has been added, but something doesn't
      quite yet work fully there.
--------------------------------------------------------------------------------
(74) → ry atk --ntrad --is-on-gobolinux
      ^^^ enable this
--------------------------------------------------------------------------------
(75) → errors.yml
      ^^^ fgather ALL errors here.
--------------------------------------------------------------------------------
(76) → run through a chain again aka a chroot.
--------------------------------------------------------------------------------
(77) → Wenn die configure stage failed, dann brauchen wir auch gar
      nicht make aufrufen:
      result = `./configure`
--------------------------------------------------------------------------------
(78) → someone on IRC: "If only i could feed a Dependencies-dump back into
      CheckDependencies and get a list of actual dependencies
      that violates the ones listed for the recipe."
      reply: sounds like a feature request!
      reply: I am not sure I understood it though
      someone on IRC: ah, never really looked at BuildInformation
      someone on IRC: ok, given that i think we can say i would like
      to run a comparison between BuildInformation and Dependencies
      in some way to indicate missing or obsolete info in the latter
--------------------------------------------------------------------------------
(79) → https://github.com/calf-studio-gear/calf/archive/0.90.0.tar.gz
      ^^^ support github variants like the above
      this should automatically fix-in the right
      name of the program at hand (auto-determine name)
--------------------------------------------------------------------------------
(80) → add:
      compilation_failed
--------------------------------------------------------------------------------
(81) → use an option glib schema or so
      that allows us to install into glib schema
      This functionality now exists in class:
      RBT::SymlinkGlibSchema
      We need to first add a new cookbooks option called
      symlink_glib_schema: t
      and if this is true, we invoke
      SymlinkGlibSchema
      first, in rbt..compile, add SymlinkGlibSchema behaviour
      ok this works, now we must add it to cookbooks
      hmmm... nope... this already exists...
--------------------------------------------------------------------------------
(82) → 5) tar format... yes
      checking how to create a ustar tar archive... gnutar
      checking for perl... /usr/bin//perl
      checking Perl version and modules... yes
      checking for gawk... (cached) gawk
      checking for gcc... gcc
      checking whether the C compiler works... no
      configure: error: in `/Depot/Temp/rbt/texinfo-6.7':
      configure: error: C compiler cannot create executables
      See `config.log' for more details
      Unregistered error: configure_error (class: Symbol)
      Unregistered error: configure_error (class: Symbol)
      RBT::Compile: ⚠ The program `texinfo` could not be installed. ⚠
      ^^^ when this occurs, find out why this is fudged up
      show this to the user too:
      e 'Attempting to deduce the problem at hand ...'
      ^^^ but this needs proper analysing.
--------------------------------------------------------------------------------
(83) → Eine neue commandline option...
      --source_dir=PHP
      Das würde dann einfach in
      /home/x/src/PHP/
      nach der datei checken.
      Oder alternative nach Dir.pwd oder was auch immer...
      Das wäre hilfreich weil wir manchmal das cookbook yaml
      file nicht editieren wollen und dennoch kompilieren
      möchten, eine Datei.
      AUSSERDEM sollte es das AKTUELLE Verzeichnis ebenso testen
      und wenn wir da was finden, dieses programm das wir kompilieren
      möchten, dann weisen wir den nutzer darauf hin und kompilieren
      eben damit...
      das dann noch in rbtcgi kommenteiren.
      ry php --source-dir=php-7.4.9.tar.xz
      RBT::Compile: We will permanently set to a new source directory next (/php-7.4.9.tar.xz/)
      RBT: Setting the new source directory to point towards `/php-7.4.9.tar.xz/`.
      RBT: Storing into the file `/home/Programs/Ruby/2.7.1/lib/ruby/site_ruby/2.7.0/rbt/yaml/configuration/source_directory.yml` next.
      RBT: Will also store into the file `/home/x/DATA/PROGRAMMING_LANGUAGES/RUBY/src/rbt/lib/rbt/yaml/configuration/source_directory.yml`.
      RBT: Since that directory does not exist, it will be created now.
      RBT::Compile: Creating the directory `/php7.4.9.tar.xz/php/` next.
      RBT::Compile: Creating the directory `/php7.4.9.tar.xz/php/` now.
      RBT::Compile: Downloading http://us3.php.net/distributions/php-7.4.9.tar.xz
      RBT::Compile: into the directory /php7.4.9.tar.xz/php/ now.
      ================================================================================
      wget http://us3.php.net/distributions/php-7.4.9.tar.xz
      --2020-08-07 05:35:36--  http://us3.php.net/distributions/php-7.4.9.tar.xz
      Resolving us3.php.net (us3.php.net)... 2a02:cb40:200::1ad, 185.85.0.29
      Connecting to us3.php.net (us3.php.net)|2a02:cb40:200::1ad|:80... connected.
      HTTP request sent, awaiting response... 301 Moved Permanently
      Location: https://www.php.net/distributions/php-7.4.9.tar.xz [following]
      --2020-08-07 05:35:37--  https://www.php.net/distributions/php-7.4.9.tar.xz
      Resolving www.php.net (www.php.net)... 2a02:cb40:200::1ad, 185.85.0.29
      Connecting to www.php.net (www.php.net)|2a02:cb40:200::1ad|:443... ^C/Depot/jj/^C
      ^^^^^^ what the heck?
--------------------------------------------------------------------------------
(84) → 2)
# ========================================================================= #
# === feedback_warning_conflicting_options_were_given
#
# This warning is feedbacked when we have a conflicting option given.
# ========================================================================= #
      def feedback_warning_conflicting_options_were_given
      opn; warn 'Warning: You are trying to use both "'+@use_traditional_strategy[0]+
      '" and "'+@use_traditional_strategy[1]+'" for the option --prefix=.'
      opn; warn 'You should decide on one or the other instead. The current way'
      opn; warn 'to solve this ambiguity is by favouring the last given option, which'
      opn; warn 'is "'+@use_traditional_strategy[1]+'" in our example. Thus '+
      'we now '
      opn; warn 'use the "'+@use_traditional_strategy[1]+'" option.'
      sleep 0.8
      end
--------------------------------------------------------------------------------
(85) → ry gcc3 --help gew egw gewegew
      ry nano --version=2.0.6
      ry php --nocolour
      '--source_dir=[val]') { |v|
      't','--this_file=[val]','Assign a new file to use') { |v|
      -v', '--version=[val]', String, 'Use specific versions') { |version|
      ^^^ ensure this
--------------------------------------------------------------------------------
(86) → Add means to use an existing file too. hmm.
--------------------------------------------------------------------------------
(87) → Add a way for the cookbooks project
      to use additional directories for checking dataset
      API could be:
      cookbooks.add_this_directory_to_the_load_path()
      also... hmm ... we should use a configuration setting
      or so about where to search for individual cookbooks
      that will then allow us to use more entries
      dazu müssen wir return_default_location_of_this_cookboo
      changen, und das testen wir in dem wir ein neues
      verzeichnis anlegen
--------------------------------------------------------------------------------
(88) → "We have compiled these successfully... however these have failed
      for some reason" (das sollte gespeichert werden... frage... wie
      finde ich raus das das geFAILED is??? hmm
      Auch in chained compiling.
--------------------------------------------------------------------------------
(89) → when we have idiots like boost who insist on renaming crap to
      boost_1_55.tar.bz2
      we will repackage this, and also inform the user about it.
--------------------------------------------------------------------------------
(90) → Whenever we compile a program, we should add this program to a
      database - DatabaseStorer
      Das machen wir mit Sqlite.
      Langfristig sollten wir das aber auch in eine Mysql
      Database erlauben.
      ^^ Da sollten wir uns wieder mal PHP anschauen. Und php mit
      mysql testen... da lernen wir mysql.
--------------------------------------------------------------------------------
(91) → Introduce:
      ry glib --compile-version=2.16.33_ROEBE
      ^^ second variant works now, first one above not yet, not sure
      about it anyway, have to think about it more than before.
      AND also add this to the documentation.
      Ist halt eben über configure option das man zwar
      (1) 2.18.3 extrahiert
      ABER
      (2) eine andere Compile Version zur Laufzeit verwendet
      Also document this extensively.
      die idee ist das wir einfach einen anderen namen geben können
      also erstmal --compile-version hinzufügen
      ^^^ ok ist nun da! \o/
      bl rbtcgi
--------------------------------------------------------------------------------
(92) → Wenn wir etwas extrahieren, aktuelles binutils z.bsp dann kann der
      extrahierte Verzeichnisname mal nicht übereinstimmen.
      beispiel:
      ftp://ftp.gnu.org/gnu/binutils/binutils-2.21.1a.tar.bz2
      binutils-2.21.1a
      wird zu
      ftp://ftp.gnu.org/gnu/binutils/binutils-2.21.1.tar.bz2
      binutils-2.21.1
      Das ist total falsch.
      Wir müssen also:
      (a) checken das der name ok ist.
      - Falls ja, machen wir silently weiter.
      - Falls nein, weisen wir den Anwender darauf hin
      und sagen das er das repackagen soll.
      Zudem suchen wir aber nach einem ähnlichen package, und wenn
      wir eines finden warten wir auf user input, und falls er ja
      sagt, gehen wir in das verzeichnis rein und kompilieren
      das stattdessen. <-→ aber, wenn wir fertig sind, weisen
      wir den anwender erneut daraufhin so das er das nit
      vergisst.
      IF ALL THE ABOVE IS DONE, THIS POINT CAN BE REMOVED.
--------------------------------------------------------------------------------
(93) → http://www.linuxfromscratch.org/lfs/view/development/chapter02/introduction.html
      → Wir sollten ein "Linux from Scratch" bzw. eine Art LSF über die
      RBT Scripts laufen lassen können.
      ^^^ ANFANGEN.
      ry php lfs
      ABER BEVOR WIR DAS MACHEN, SCHAUEN WIR DAS UNSERE SHELL SCRIPTS FUNZEN.
      ^^^ zudem austesten wie wir das ganze optimieren können.
--------------------------------------------------------------------------------
(94) → add a way to designate a different appdir directory
      ry htop --use-this-program-dir=/j
      ry htop --use-this-programs-dir=/j
      ^^^ this will then become the new programs dir for the current
      compile run
      ALSO DOCUMENT THIS SHIT, LOOK THAT THE DOCUMENTATION IS GOOD
      THEN REMOVE THIS ENTRY.
--------------------------------------------------------------------------------
(95) → Langfristig sollten wir Fehlermeldungen aufbereiten so das der
      Anwender sie versteht.
      config.log saugt ...
      class ParseConfigureHelp:
      macht dies bereits teilweise.
--------------------------------------------------------------------------------
(96) → -W, --no-web
      Do not check remote site for recipes, and bypass
      fetching of archives.
      ^^^ add a way to integrate a remote cookbook
      for this, perhaps add a remote ftp site.
      Hmmm. Yep, first add the remote ftp site.
--------------------------------------------------------------------------------
(97) → when we do "rnsymc" in a directory like
      /Programs/Libxcb/Current
      we also remove inactive files - this functionality
      should be passed into a new standalone .rb file,
      a class that just does that very action, so
      that it can also be used from the commandline.
      what do we mean with inactive files?
      Removing these (empty) directories next:
      ["/Programs/Xrdb/1.1.0/share/"]
      ^^^ this here
--------------------------------------------------------------------------------
(98) → implement a small subset of sed for rbt
      ^^^ this works for at the least one input;
      need to test more input before we can
      declare this as finished.
--------------------------------------------------------------------------------
(99) → Spaceghostc2c> havenn¦ I prefer aptitude and checkinstall.
      reply: checkinstall? what does that one do?
      Spaceghostc2c> Packages your source up in a deb for you.
      ^^^ we need to be able to create deb archives.
--------------------------------------------------------------------------------
(100) → I'll try to think of a list:
      → Tutorial / Docu must be improved
      - CHECK THROUGH THE WHOLE TUTORIAL
      - REWORK IT, TEST IT
      - ALSO ADD IT TO REMOTE FTP SITE
      - THEN REMOVE THIS HERE
      - THEN UPLOAD RTB
      Improve, improve, improve.
      ^^^ Wir sind stehengeblieben bei position 200 oder so.
      GOTT IST DAS LANGWEILIG!!!
      bl rbttut
      rf rbttut
--------------------------------------------------------------------------------
(101) → === autocompile functionality
      enable:
      → autocompile in the compileshell
      that shall test as to what we should compile
      STARTING WITH THE LEAST CONTROVERSIAL ONES
      AND IDEALLY INTO /Programs dir
      expand this...
      and start it via "autocompile"
      also allow auto_compile
      document this as well
      ^^^
      → Wir müssen rausfinden die komplette size von bestimmten programmen
      cookbook --size htop,php,ruby
      cookbook --size tag:gnome
      oder das erste:
      cookbook --size "htop,php,ruby"
      cookbook --size "php,ruby,perl,python"
      cookbook --size="htop,php,ruby"
      cookbook --size="php,ruby,perl,python"
      Letzteres funzt nun. Die anderen Punkte funktioniere
      aber noch nit, also behalten wir diesen Punkt vorläufig.
--------------------------------------------------------------------------------
(102) → dump yaml
--------------------------------------------------------------------------------
(103) → we need a way to generate a STATIC dataset, ideally in SQL,
      so that we don't have to use a bunch of yaml file.
--------------------------------------------------------------------------------
(104) → Work through both cookbooks and rbt-todo. Just for quality
      improvements.
--------------------------------------------------------------------------------
(105) → we had a strange conflict in where dpkg had wrong names registered
      as part of the binaries:
      section.
      Thus, we need some way to find out, at the least
      when we apply "regall" - it should warn us ahead before this happens.
      if already has this name?
      report to the user; also exit optionally
      end
--------------------------------------------------------------------------------
(106) → Note that sometimes a user may wish to group-update a list of existing
      cookbooks to some new cookboks, like after a year or so.
      In order to do so, we need to make this possible.
      but how yet, I don't know...
      we perhaps need a way to find out which programs were
      compiled, so we may have to keep a database of installed
      files AND as a first step, we will only update from
      that database.
      "Php was installed march 2015. There is a new versiopn
      available. We thus register it for upgrading."
--------------------------------------------------------------------------------
(107) → try_to_use_the_file_windows_cookbook.yml
      ^^^ enable support for windows_cookbooks.yml again
      but this requires proper loading of this dataset onto the main
      hash
--------------------------------------------------------------------------------
(108) → First off you need to create a build folder and an archive
      of your files: tar czvf data.tar.gz files
      Then in the build folder you must create a control file with some wanted informations:
      Package: xxxxxx
      Version: 0.0.1
      Section: user/hidden
      Priority: optional
      Architecture: armel
      Installed-Size: `du -ks usr|cut -f 1`
      Maintainer: Your Name <xxx@xxx.xx>
      Description: This is optional, but creates warnings if left out
      ^^^ create a debian control file
--------------------------------------------------------------------------------
(109) → brew install imagemagick@6
      > If you don't specify @6 it will install the latest
      > version by default. I had issues with version 7 on
      > Linux so I decided to use older versions for both
      > macOS and Linux.
      ^^^ here also support this syntax
      and document this but first make sure that this fits.
--------------------------------------------------------------------------------
(110) → improve the part on slackware package creation
      and test it more.
--------------------------------------------------------------------------------
(111) → add:
      rbt --do-postinstall-step
      ^^^ do only the postinstall step, no other step
      document this as well.
      The functionality was added but we have to
      test this. That is currently a bit cumbersome
      since the initialize-step for RBT::Compile is not
      sufficiently decoupled to allow for the postinstallation
      step to occur decently well. We have to rewrite that part
      eventually, into:
      a) an initializion step that also honours the proper
      prefix and builds up our object that way
      AND
      b) also a postinstallation step that can be used properly
--------------------------------------------------------------------------------
(112) → we need a way to enable defaults that help
      most people; not just me alone, so things
      such as "strip" should not be enabled by default.
      only for me, or when the user specifically
      has this enabled.
      also specify some default values for other
      people in some file... some .yml file or
      so; only specify the ones that have to
      be set to a certain value, listing them
      in a linear manner in that .yml file.
      default_settings_for_rbt.yml
--------------------------------------------------------------------------------
(113) → enable automatic creation fo slackware package and put it
      into
      /Depot/Package/
      via yaml file
      if uses_slackware?
      hmmm
--------------------------------------------------------------------------------
(114) → ry gdb ntrad --use-this-source-location=/Mount/USB1/last_backup/src/gdb/gdb-8.2.tar.xz
      ry gdb ntrad --use-this-source-location=/Depot/j/gdb-8.2.1.tar.xz
      ^^^ enable this and document it as well
      including several examples ...
      this does not work too terribly well right now.
--------------------------------------------------------------------------------
(115) → RBT::RegisterProgramFilesIntoYamlDatabase:   `/Depot/Temp/rbt/htop-2.2.0/BUILD_DIRECTORY/yaml/registered_files.yml`.
      RBT::Cookbooks::Cookbook: The program /depot/temp/rbt/htop2.2.0/builddirectory does not appear to be registered.
      RBT::RegisterProgramFilesIntoYamlDatabase: Getting all files from `/Programs/programs/htop/2.2.0/` next.
      RBT::RegisterProgramFilesIntoYamlDatabase: We will not store the registered files as
      RBT::RegisterProgramFilesIntoYamlDatabase: the dataset is empty.
      ^^^^ this is now broken....
      we also have to fix that strange downcasing crap there.
      hmmmmmmmmmmmmmmmmmmm........ what the actual fuck dude
--------------------------------------------------------------------------------
(116) → contiue to port old code - yup did this today on 12.04.2019 \o/
--------------------------------------------------------------------------------
(117) → we need to be able to work with locally existing files
      ry foobar-1.0.tar.xz
      and infer all information from that
      first, guess the directory
      this works, somewhat - need to test it more though.
--------------------------------------------------------------------------------
(118) → When a libtool error happns, not only autofix it but also add a way
      to re-compile. But add a limit like 5 times or so to this.
      ihash?[:we_tried_to_compile_this_program_n_times] = 0
      ^^^ default
      increment per re-run
      and re-set to zero upon a new program is loaded up.
      if try_to_recompile_upon_error
      increment_compiled_this_program_n_times_counter
      end
      ^^^ this works now, somewhat, but has to be documented.
      and checked again hmm.
--------------------------------------------------------------------------------
(119) → make porg available again !!!
--------------------------------------------------------------------------------
(120) → enable:
      ry compile-gcc=8.1.0
      hmmm to just re-use the old configure part in use right now
--------------------------------------------------------------------------------
(121) → test setting up an older computer below ... and then another
      one behind my back
      AND TEST RBT ON BOTH!
      hmmmmmmmmmmm
      test on my laptop...
--------------------------------------------------------------------------------
(122) → When we have finished compiling a progrem, de-register it again
      from the "currnetly compiled programs"
      ▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁
      RBT::Compile: The program `blueman` will be compiled/installed next.
      ^^^
      das muss geändert werden
      in --→ statt ___
      unicode_middle_cliner
      hmm
--------------------------------------------------------------------------------
(123) → make it so that
      trad lua
      woRKS.... out of the box
      ...........................................................
      Rewrite rbt but only after
      finsihing on string_img
      When we rewrite it, focus on gathering information as to
      whether a program has completed successfully or whether it has not.
      if yes, store information about the process somewhere
      but also store the dataset from the program that has
      been installed, so that we can more easily query
      whether another program (dependency) has been satisfied
      already.
      ...........................................................
      Write some master class that can be used to check some key
      websites for news, e. g.
      → slackware
      → blfs changelog
      and so forht.
      and it shall present some information based on
      this
      then extend it slowly
      the key idea here is to spend less time on
      updating my homes ystem.
      ALSO DOCUEMTN IT
      ^^^ damit das funktioniert
      benötigen wir wohl ein paar klassen die das für uns
      herausfinden können
      eventuell eine WebScraper class oder so.
      oder ein modul hmm
      subclas vo Base
      und dann noch ein webscraper module oder so
      das hamma eh schon oder?
--------------------------------------------------------------------------------
(124) → === Improve the whole handling of xorg-server
      so that we run into less problems here in
      the long run.
      We need to think more about this e. g. why starting the xorg
      server may fail. These problems should not occur; and if they
      still occur then we need to provide sufficient and helpful
      information to the user how to resolve these problems.
      ry xorg55 ntrad
--------------------------------------------------------------------------------
(125) → RBT::PostinstallationStep: Now running RBT::SymlinkThisProgram to symlink the content of `/Programs/Brotli/1.0.2/`.
      RBT::SymlinkThisProgram: Deleting the symlink found at /Programs/Brotli/Current.
      RBT::SymlinkThisProgram: Now symlinking from /Programs/Brotli/Brotli to /Programs/Brotli/Current.
      ^^^ what the ...
--------------------------------------------------------------------------------
(126) → Continue towkring on validate all cookbook entries
      and perhaps improve the documentation as well
--------------------------------------------------------------------------------
(127) → begin working on a compile shell + status shell
      Works quite fine so far.
      We need to add a status command still though.
      'stats,
      'status'
      ^^^  enable a stats and status overview
      telling us which programs were last compiled
      and so forht
--------------------------------------------------------------------------------
(128) → add a --lfs-tools option
      this shall compile ... into HOME_DIR/tools
      all the stuff that the lfs requires... hmm
      so essentially we pass an array of programs and
      then the configure options
      perhaps via profiles, let's see.
      ^^^ work throug LFS for this again
      http://www.linuxfromscratch.org/lfs/view/development/
      Something isn't working here very well.
--------------------------------------------------------------------------------
(129) → Extend:
      class RBT::Toolchain
      We need to make sure that it actually works from A to Z. And next
      time try it with the LFS user instead. And perhaps /tools directly
      with a mounted USB device. Hmmmmmm.
--------------------------------------------------------------------------------
(130) → make it possible to create slackware packages !!!
      THE GOAL is to make this easily so.
      I guess we first have to test this more thoroughly.
--------------------------------------------------------------------------------
(131) → DEAL WITH SQL
      add a wrapper for sql. improve on it. Read up on sql.
      DOCUMENT these strategies in the main RBT doc too
--------------------------------------------------------------------------------
(132) → RBT→Symlink: Can not symlink - the file at `/home/Programs/Xfce4terminal/Current` already exists.
      ^^^^ perhaps colourize the → part there →
--------------------------------------------------------------------------------
(133) → rbt:
      ry utillinux --ntrad --statically --create-slackware-package
      ^^^ this shall be possible one day.
--------------------------------------------------------------------------------
(134) → Find a way to show which entries in RBT were updated since the last release.
      This is probably easily done - updateentry already keeps track of releases
      in a .yml "database", as a first step.
      Then, when we do a new release, we grab that entry and well ... delete it
      for now (though we should probably keep this as a permanent hash rather
      than delete it hmmmmmm).
      ^^^^
      ^^^ nah, w e just store the time stamp instead.
      DANN UPLOADEN
      Ok we now also store the timestamp. What is missing is to correlate this
      with an updated release every time the project is pushed.
      So we have to obtain this information and then publish this at a later
      time.
      ^^^ add a new subsection into RBT readme too
      to showcase which programs were updated
      if none:
      'No programs were updated since the last release at XYZ.'
      else
      The following programs were updated at xy8:
      bison (new version is: 5.2.2.)
      and so forth
      sort of create an auto-changelog thingy.
      ^^^ no change this...
      we store it somewhere else
      in a dedicated directory I think
      fitting to the version at hand ....
      call it:
      new_release/ or so
      awww ..........
      or I guess I store into a new databse altogether
      call the database:
      updated_entries.yml
      and in that, store in a linear fashion the
      1) NAME of the program
      2) the remote URL
      3) the PROGRAM_VERSION
      4) hmmm... and WHEN it was updated, including the
      exact timestamp.
      ^^^ ONCE THIS WORKS, WE CAN TRANSITION INTO
      ADDITIONAL SOLUTIONS. And perhaps also
      well..
      ^^^
      also create a new script that takes the information
      from expanded_dataset,
      and then dumps the version quickly into a new
      file.
      first create a transition class, a meta-class
      call it:
      AggregateInformationFromTheExpandedCookbooks
      ^^^ this class now exists; let's see what we can do with it.
--------------------------------------------------------------------------------
(135) → enable a new entry point for an existing
      binary aka:
      ry --use-this-file-as-input=/Depot/j/ffmpeg-4.2.2.tar.xz
      ^^^ and try to deduce from there.
      infer_information_from_this_archive
      ^^^ continue from there.
      But perhaps we have to re-design class RBT::Compile, so
      that the loading of the yaml-dataset is decoupled here.
      Hmmmmm.
--------------------------------------------------------------------------------
(136) → Hmm. Aliases already exist for the ones defined in the yaml
      file. But perhaps we should add aliases to EVERYTHING. This may
      require some kind of ... configuration setting.
      We also have to keep in mind which settings have priority.
      postgre - postgresql
      this should work...
      hmm probably add this into Aliases directly...
--------------------------------------------------------------------------------
(137) → The old code tried to handle global flags, in configure.
      Not sure if we still need it though.
# ===================================================================== #
# === Handle global flags next
# ===================================================================== #
      if File.exist?(FILE_GLOBAL_FLAGS) and
      !File.empty?(FILE_GLOBAL_FLAGS)
      use_these_global_flags = File.read(FILE_GLOBAL_FLAGS).strip
# ===================================================================== #
      But make sure that the global flags are not already part of the
# configure line.
# ===================================================================== #
      unless _.include? use_these_global_flags
      opne 'We will now append these global flags: '+
      sfancy(use_these_global_flags)
      _ << " #{use_these_global_flags}"
      end
      end unless use_this_configure_line
      → add a way to check which programs are currently compiling.
      this should probably happen in a new .yml file altogether,
      where we register when we start to compile something;
      and when it has finished, we will de-register again
      AND when an exit happens
      also afterwards be able to query from he commandline what
      this does
--------------------------------------------------------------------------------
(138) → optimize linux kernel builds; ideally make them fully automatic through
      rbt.
--------------------------------------------------------------------------------
(139) → someone: i got an error about guid id rather just be warned in red
      or something if theres a permission error and not have rbt trying
      to do things itself (or at least without asking me).
      ^^^ Valid complaint.
--------------------------------------------------------------------------------
(140) → Auswahl recipes/packages/beides, - liste installieren.
      IN ORDER TO TEST THIS WE NEED A WAY TO LOGIN TO A FTP
      SITE AND UPLOAD A RECIPE! We can do so already.
      * Steps to perform:
      getrecipe (from gobolinux as default
      (2) upload it to UNET site or somewhere else [IMPLEMENTED ALREADY]
--------------------------------------------------------------------------------
(141) → Improve the error handling in general.
      when an error is encountered, feedback to
      the user which error happened and what to do about it.
      We first have to collect all errors in a specific file.
      Once that file is good enough we'll transition to it.
--------------------------------------------------------------------------------
(142) → perhaps create a new class called
      LoadExpandedCookbookDataset
      This shall only load the expanded .yml file; that way we don't have to
      sanitize anything. \o/
--------------------------------------------------------------------------------
(143) → 5) spack install hdf5@1.10.1
      rbt glibc@2.27 --ntrad --dont-use-configure-options --dont-symlink
      ^^^ consider this versioning scheme as well,
      or something like that
      ^^^ yeah as a simpler alternative
      hmmm
--------------------------------------------------------------------------------
(144) → 3) fix that auto-register thingy
--------------------------------------------------------------------------------
(145) → 2) LOOK AT OLD RBT CODE
      → port what is useful
      → kill what is outdated
--------------------------------------------------------------------------------
(146) → Manchmal will man eine bestimmte USE-Einstellung nur einmal
      benutzen.  Anstatt das /etc/make.conf zweimal editiert wird (um
      die Veränderungen
      in USE anzuwenden und wieder zu entfernen) können Sie einfach die
      USE-Variable als Umgebungsvariable definieren.
      - yup der anwender sollte dies auch können. Wird mittels
      @environment_use_flags
      realisiert werden... aber zuvor müssen wir USE FLAGS verbessern. :/
      Mit den USE Flags ist es so. Sie sind per default global und können
      verwendet werden um etwas spezifisch zu enablen oder zu disablen.
      Z.Bsp bedeutet -kde das man niemals KDE Support haben will.
      Das wirkt global, wann immer man etwas kompilieren möchte.
      Es geht aber auch per-package und fungiert so quasi als ein Switch
      zu GNU configure.
      Da muss man sich auch etwas zu der Precedence überlegen.
      Rebuilding your entire system
      emerge --update --deep --newuse world
--------------------------------------------------------------------------------
(147) → http://shevegen.square7.ch/programs_version.html
      ^^^ hmm ... also add a more detailed overview than that.
      showing also the remote URL well
      hmmm perhaps use another .html file for this though.
--------------------------------------------------------------------------------
(148) → Eine Klasse erstellen die eine sqlite datenbank erstellt
      aus den verschieden yaml datensätzen.
      class GenerateDatabase
      bl $MY_COOKBOOKS/utility*/create_database.rb
--------------------------------------------------------------------------------
(149) → Add a way to automatically download and repackage.
      if "is not in .tar.bz2 format"
      repackage_this_to('file.gz', 'file.bz2')
      repackage() # this method exists in Installer already.
      Must be tested first though.
--------------------------------------------------------------------------------
(150) → port @install_package
--------------------------------------------------------------------------------
(151) → 3) add a script that can turn all traditional stuff into
      gobolinux variant. What does this even mean? Does this refer
      to traditional: f to traditional: t?
      hmmmm no clue. Remove the above at the end of 2020 if not resovled.
      (155) → @continue_after_configure_step = $?.success?
      ^^^ do we need that? hmm
--------------------------------------------------------------------------------
(152) → Run "make check" next if this was specified. Disabled for now
# though.
# if sload.run_make_check
#   opnn;e 'Now running '+make_command?+' check'
#   sys make_command?+' check', @use_systemu # Run "make check" here.
# end
      ^^^ consider re-enabling make check again.
--------------------------------------------------------------------------------
(153) → Makefile.linux
      ^^^ ensure that this can be a success.
--------------------------------------------------------------------------------
(154) → GNUmakefile
      ^^^ support for this ? hmmmmmm.
      But how many programs support this?
--------------------------------------------------------------------------------
(155) → Enable to use the current working directory as input:
      /Depot/jj/libxkbcommon-0.7.2/
      ^^^ such as this one here
      ry --use-current-working-directory-as-input
      ^^^ this works to some extent... but not completely.
      continue on it lateron.
      What shall it do? Hmm. Guess at the least it
      should use "libxkbcommon"; perhaps also version
      but not sure. Definitel the program name though.
      AND THEN DOCUMENT IT.
      This works almost - the build directory logic is incorrect.
      We may have to reconsider it.
--------------------------------------------------------------------------------
(156) → We should perhaps add a .yml file to determine whether to
      use shortcuts and abbreviations ... not sure if yes or
      not ... think about it.
      Actually the user should be able to determine whether
      to use shortcuts and abbreviations, both in
      the yaml file and also via the commandline as a flag
      use_abbreviations.yml
      ^^^ add this. This was now added, and it works! \o/
      But we need to add from the commandline that a user
      can toggle this, so add this:
      ry ph --do-not-use--abbreviations
      ry ph --no-abbreviations
      and --use-abbreviations
--------------------------------------------------------------------------------
(157) → improve the steps necessary for a chroot, then switch it.
      We need to improve all steps to upgrade glibc.
--------------------------------------------------------------------------------
(158) → -O3
      add:
      rbt --sed -O3
      for -O3 optimziation
      and add:
      -march=native
      so -O3 works and has been documented. We still have to deal
      with -march=native though...
      we added support for this in june 2020. But this may have
      to be better optimized.
--------------------------------------------------------------------------------
(159) → trad  mate-panel-1.21.3.tar.xz
      RBT::Compile: The program `matepanel1.21.3.tar.xz` could not be found. We thus can not
      RBT::Compile: compile it and hence, can not continue. If this file should exist,
      RBT::Compile: it could be found at:
      /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/yaml/individual_cookbooks/matepanel1.21.3.tar.xz.yml
      Traceback (most recent call last):
      9: from /Users/x/DATA/PROGRAMMING_LANGUAGES/RUBY/src/roebe/lib/roebe/toplevel_methods/trad.rb:27:in `<main>'
      8: from /Users/x/DATA/PROGRAMMING_LANGUAGES/RUBY/src/roebe/lib/roebe/toplevel_methods/trad.rb:14:in `trad'
      7: from /Users/x/DATA/PROGRAMMING_LANGUAGES/RUBY/src/roebe/lib/roebe/toplevel_methods/trad.rb:14:in `new'
      6: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/initialize.rb:140:in `initialize'
      5: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/run.rb:28:in `run'
      4: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/batch_compile_the_programs.rb:27:in `batch_compile_the_programs'
      3: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/batch_compile_the_programs.rb:27:in `each'
      2: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/batch_compile_the_programs.rb:28:in `block in batch_compile_the_programs'
      1: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/do_compile_this_program.rb:231:in `do_compile_this_program'
      /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/cookbook_dataset.rb:98:in
      `archive_type?': undefined method `archive_type?' for nil:NilClass (NoMethodError)
      ^^^^ das sollte automatisch splitten in version...
      trad mate-panel-1.22.1.tar.xz
      ^^^ das existiert auch lokal
      aber das kompiliert net gscheit.
      ^^^ DANNN hochladen.
--------------------------------------------------------------------------------
(160) → enable:
      autoupdate vala --only-libs
      autoupdate vala --only-libraries
      autoupdate gnomedesktop --only-libs
      ^^^ to only update libraries
      test it then add to docu
      hmmm this has been added but it does not seem
      to work very well? It works a bit. But not very well.
      ry scummvm --ntrad --use-this-version=2.1.2
--------------------------------------------------------------------------------
(161) → RBT::Compile: Overruling any potential traditional setting.
      RBT::Compile: Setting to the specific version `2.1.2` now (for the program scummvm).
      RBT::Compile: The program `scummvm` will be compiled next.
      RBT::Compile: Removing the old directory at `/home/Temp/rbt/scummvm-30.06.2020/`.
      RBT→Extracter: Extracting `/home/x/src/scummvm/scummvm-30.06.2020.tar.xz` to `/home/Temp/rbt/` next.
      RBT→Extracter:   tar -xvf /home/x/src/scummvm/scummvm-30.06.2020.tar.xz -C /home/Temp/rbt/
      ^CRequesting a graceful exit from class Extracter. Exiting now.
      An error has happened upon attempting to run this system command:
      tar -xvf /home/x/src/scummvm/scummvm-30.06.2020.tar.xz -C /home/Temp/rbt/
      ^^^ why does this fail?
--------------------------------------------------------------------------------
(162) → 
# ======================================================================= #
# We can register our program in a database now:
# ======================================================================= #
      intercept_database_creation # maybe we want to create or modify databases
--------------------------------------------------------------------------------
(163) → ry binutils trad --use-this-version=binutils-2.29.tar.xz --dont-use-configure-options
      RBT::Compile: Using a "traditional" strategy for compilation (which means prefix /usr/).
      RBT::Compile: Setting to the specific version `2.29` now (for the program binutils).
      RBT::Compile: No configure options will be used for this run.
      RBT::Compile: The program `binutils` will be compiled/installed next.
      = Infobox ======================================================================
      |                               |                                              |
      | Compiling this program:       | binutils                                     |
      | Prefix:                       | /Programs/Binutils/2.29/                     |
      | Program version:              | 2.29                                         |
      | Program path:                 | /Users/x/SRC/binutils/binutils-2.29.tar.xz   |
      | Keep the archive extracted:   | Yes.                                         |
      | Will be extracted towards:    | /Depot/Temp/rbt/binutils-2.29/               |
      | Will ccache be used:          | Yes.                                         |
      | CFLAGS in use:                | -O2 -fPIC -fno-strict-overflow -Wno-error    |
      | Use a build directory:        | Yes.                                         |
      | Host architecture in use:     | x86_64                                       |
      |                               |                                              |
      ================================================================================
      RBT→ Extracter: Extracting `binutils-2.29.tar.xz` to `/Depot/Temp/rbt/` next.
      RBT→ Extracter:   tar -xvf /Users/x/SRC/binutils/binutils-2.29.tar.xz -C /Depot/Temp/rbt/
      RBT→ Extracter: Finished extracting to `/Depot/Temp/rbt/binutils-2.29/`.
      RBT::Compile: Entering the directory /Depot/Temp/rbt/binutils-2.29/
      RBT::Compile: Now entering the directory `/Depot/Temp/rbt/binutils-2.29/BUILD_DIRECTORY/`.
      RBT::CreateProgram: Binutils-2.29 (Program name: Binutils and Program Version: 2.29)
      RBT::CreateProgram: The target directory will be at `/Programs/Binutils/2.29/`.
      RBT::CreateProgram: Several subdirectories will now be created in that directory, namely:
      RBT::CreateProgram:   bin/, include/, lib/, man/, sbin/, Shared/, Resources/
      RBT::CreateProgram: Done!
      RBT→ Symlink: Symlinking /Programs/Binutils/2.29/ into /Programs/Binutils/Current.
      ================================================================================
      CC="ccache gcc" /Depot/Temp/rbt/binutils-2.29/configure --prefix=/Programs/Binutils/2.29/ 2>&1
      ================================================================================
      ^CRequesting a graceful exit from class Extracter. Exiting now.
      /Users/x/SRC/binutils/^C
      /Users/x/SRC/binutils/ry binutils trad --use-this-version=binutils-2.29.tar.xz --dont-use-configure-options^C
      /Users/x/SRC/binutils/
      ^^^ BUG wir haben ja traditional gegeben...
--------------------------------------------------------------------------------
(164) → in rbt, reconsider "make use of cookbook aliases" setting
      is it needed?
--------------------------------------------------------------------------------
(165) → enable openssl compilation
--------------------------------------------------------------------------------
(166) → --use-gnu-configure
      ^^^ enayble this again to specificyll overrule anything
      else; and test it on pygtk
      start a success/failure thing
      ANd also a summary of what has been compiled, success: yes/no
      and the host system and so forth.
      ^^^ but store this summary only for registered
      programs? hmmm not sure
      OR perhaps we do this at another time hmmm
      and just finish the re-write...
      @do_not_use_special_flags
      ^^^ fix this
--------------------------------------------------------------------------------
(167) → next step in the rbt-rewrite:
      NEXT STEP:
      → FILE_BUILD_SYSTEM_PRIORITIES
      → FINISH porting all fo cookbooks!
      ^^^ this should be enabled if we compile just from an existing
      file.
      fix:
      → also when the file exists, check what type it is aka
      via build_detector, and then proceed accordingly.
      → also add a compile: success/failure thingy and store this all
      with the information as to whether this is a 32 bit or
      64 ... eg. through the method: RBT.determine_host_architecture
      → we first have to sanitize the dataset.
      → show how to update the registered tags + improve docu
      + README.gen
      ^^^ glib- fails, so we must catch this error, and then decide
      to NOT run the "make" and "make install" step. AND we also
      must check on the error! before continuing
      ALSO, we must be able to batch-compile an array
      ALSO enable expanded cookbook set
      and when this exist,s we load it, rather than the
      unsanitized cookbook set. ^^^
      ALSO ensure that both RBT::Cookbooks.expand_cookbooks and RBT.expand_cookbooks
      works
      ALSO make sure that the chained programs work correctly, without
      strange interrupts
      ensure that we have a file called
      source_base_directory.yml
      also do:
      ue trollop
      ensure:
      RBT.generate_programs_version_yaml_file
      to work
      RBT.file_specification_of_registered_cookbook_entries
      ^^^ enable this API as well
      /System/Index/bin/ziptool → /Programs/Libzip/1.5.1/bin/ziptool
      ^^^ this is WRONG; it should point towards "Current" !
      add the option "--use-configure" to specifically force
      this build system type
      and then also go through all .rb files and
      check for rescue LoadError, whether we can remove them
      or not
      /System/Index/bin/stat ar
      File: ar → /Programs/Binutils/2.31/bin/ar
      ^^^ fix this symlinking thing... the number
      should NOT be a part!!!!!!!
--------------------------------------------------------------------------------
(168) → in rbt ... add a configure option whether to use abbreviations or
      not tothe main programs.
      enable:
      ntrad gobject-introspection-1.57.3.tar.xz
      if the file exists, use it
      ^^^ yup re-rewrite the RBT
      and cookbooks
      and merge it
      ^^^ and solve the above,
      also the step-wise compilation
      AND abbreviations!
      YAY
      FIX ALL THE THINGS
      start with:
      if File.exist?
      ^^^ extract it
      or parse it into its constituents
--------------------------------------------------------------------------------
(169) → === Store the environment information at the time of compilation
      We should store the environment information into a file
      when we have compiled/installed a program.
      And then perhaps upload this somewhere as well, in the event
      that something goes awry? Hmmm.
      That way we would know which components we have used for
      this compilation, including the PATH variable too and so
      forth.
      perhaps:
      compile.log
      We will use a class for this, called RBT::CreateLogFile.
      What shall it store? in it we should store:
      (1) PATH:
      hmm. perhaps store the full ENV variable somewhere...
      call it:
      environment_that_was_used_for_installing_this_program.yml
      dump the .yml file there.
      only use it when using an AppDir installation though.
      or better, create it twice.
      once in a subdirectory in the log dir, and once in the
      appdir.
      ^^^ ok this has been added as of 27.09.2022. Now we
      need to keep it that way and perhaps at a later
      time remove this entry here.
--------------------------------------------------------------------------------
(170) → 
      in rbt create a new class that can associate all files
      that belong to glibc into a standalone entry at /home/Programs/Glibc/ or so...
      hmm. and a secondary backup dir first, say /opt/backup/glibc/
      ^^^ enable this via rbt
      and notify the user that this is EXPERIMENTAL! DONT USE IT!
      This was created in September 2022.
--------------------------------------------------------------------------------
(171) → The directory `/home/Programs/Webkitgtk/2.38.2/lib/` can not be created
      as some target, or an incorrect symlink, already exists.
      "BBBBBB"
      RBT::CreateAppDirSkeleton: Creating the directory /home/Programs/Webkitgtk/2.38.2/man/
      ^^^ this should show the leading opn part, which it currently does not
      in this case. We may have to rewrite the underlying logic with
      that namespace: namespace? in mind
--------------------------------------------------------------------------------
(172) → In the local chroot set up muslc and test it ... hmm and compile
      different glibc variants. We did already set up musl, but this
      needs some more testing, at a later time.
--------------------------------------------------------------------------------
(173) → add windows support and test it too.
      well ... perhaps start with cmake first.
--------------------------------------------------------------------------------
(174) → Offer an easy, simplified way to cross-compile for other
      architectures. Make compiling great again! \o/
--------------------------------------------------------------------------------
(175) → support for ruby-gtk3 at the least, and design it
      precisely from that point of view FROM THE GET GO
      hopefully so that it also works on WINDOWS
      eventually!!!
      ^^^ improve ruby-gtk3 parts
      ^^^
--------------------------------------------------------------------------------
(176) → ry M4 --ntrad --use-this-as-program-name=M62
      ry M4 --ntrad --use-this-as-program-name=M62
      ^^^ some bug - this is ignored. how strange :(
      ^^^ THIS MUST BE FIXED
--------------------------------------------------------------------------------
(177) → investigate how to turn this all into SQL statements.
      and store it into a sql database via sequel
      and query it
--------------------------------------------------------------------------------
(178) → dnf install @kde-desktop-environment
      ^^^ perhaps add this for rbt
      so that @ can also be used to install "meta-packages"
      ^^^ so the code should check if there is a LEADING part
      before @ and if not then use the above^^^
--------------------------------------------------------------------------------
(179) → create_debian_package
      Unfinished method.
      ry python deb
      def create_debian_package
      CreateDebianPackage.new(dataset?)
      exit_program
      end
      ^^^ re-enable that
      we must be able to create debian packages
--------------------------------------------------------------------------------
(180) → add some way to check a system for its compile possibilities
      e. g. a status "bar" that can also be shown in the
      compile shell such as
      GCC version is at bla
      g++ is available yes/no
      and so forth
      system_compile_possibilities.rb
      SystemCompilePossibilities
      ^^^^ also document it then
      also explain how this can be used
      ^^^ add some class called
      RBT::StoryTelling
      it will tell us what this system has.
      need to test this on a bare-bones system hmm.
      isnt this envi? hmm.
      Well, the functionality is already available via
      envi ... Do we need a more sophisticated variant?
--------------------------------------------------------------------------------
(181) → ./configure  LDFLAGS="-static -static-libgcc" CPPFLAGS="-static"  --disable-shared --enable-profiling --prefix=/root
      make LDFLAGS="-static" LINKFORSHARED=" "
      make install
      ^^^ hmmmmmmmmmm ...
--------------------------------------------------------------------------------
(182) → handle_binary_installation
      ry supertux install
      or
      ry fox package
      ry fox binary
      def handle_binary_installation(input)
      @install_package.handle_binary_installation(input) # bl $RBT/InstallPackage.rb
      exit_program
--------------------------------------------------------------------------------
(183) → run_as_user
      re-enable this:
      Run as a specific user. The argument `this_user` should be a string
      that specifies the user_name, i.e. "root" or "debug". It will default
      to the user name "root. If we are on windows, we will section for now.
      The User "debug" would be this:
      Process.egid =  100
      Process.euid = 1000
      def run_as_user(this_user = 'root')
      unless is_on_windows?
      _ = Users.new
      this_user = _.superuser_name? if ['default','superuser'].include? this_user
      new_euid, new_guid = _.fetch_user(this_user)
      begin
      Process.egid = new_guid
      Process.euid = new_euid
      rescue Errno::EPERM => error
      opn; warn '[Notice] You do not seem to have sufficient permissions '+
      'to alter the GroupID (gid).'
      opn; fancy error
      end
      end
      end
--------------------------------------------------------------------------------
(184) → Re-enable: install_every_package
# installs every package in PKG_DIR, uses method do_real_install to
# really install a pkg.
#
# Invoke this method like so:
#
#   ry --install-every-package
      def install_every_package
      get_file_listing(@pkg_dir, true).each { |tmp|
      do_real_install(tmp)
      }
      end
--------------------------------------------------------------------------------
(185) → Allow for:
      installer htop@3.1.2
      that way we can avoid --use-this-program-version
      ^^^
      ^^^ must test the use-this-program-version= still
      also fix the error problem...hmmm
--------------------------------------------------------------------------------
(186) → Working with an existing binary should work as-is without
      leading to compile problems. in
      bin/ hmmm
      we may have to infer things. Well actually...
      11111^^^
      (2) Must transition into more actions.
      ^^^ make each compile task that makes sense an
      action; perhaps prefix this via:
      RBT.actions(:compile_step1)
      or something like this hmm.
--------------------------------------------------------------------------------
(187) → expand errors.yml
      ^^^
--------------------------------------------------------------------------------
(188) → Fix this:
      → Introduce:
      ry glib --version=2.18.3 --compile-version=2.16.33_TEST
      ry glib@2.18.3 --compile-version=2.16.33_TEST
--------------------------------------------------------------------------------
(189) → CLANG support:
      add a way to automatically use clang for llvm ...
      via rbt... not sure how but it would be simpler.
      That works sort of but we need more experience here,
      since it does not seem to work perfectly well.
      (94) → http://developer.ubuntu.com/
      ^^^ wenn das grundgerüst hier funktioniert, die Funktionalität
      von RBT in eine ruby-gtk app reinpacken und auch dort publishen.
      ah ja, add ruby-gtk support
--------------------------------------------------------------------------------
(190) → make -f Makefile.linux
      ^^^ this supprting
--------------------------------------------------------------------------------
(191) → Implementiere folgendes (zur zeit geht das teilweise...
      all_versions fungiert als compile_all_versions):
      ry glib all_versions
      ry glib all_versions ntrad
      all_versions instruiert das man eben alle Versionen mittels
      ntrad kompiliert.
      ^^^ this works but requires class Chained so we first
      must port it to the new infrastructure, which has
      became ChainedCompiler.
--------------------------------------------------------------------------------
(192) → To stop something from being updated/upgraded:
      brew pin <formula>
      ^^^ enable this in rbt
      rbt pin htop
      rbt --pin htop
      ^^^ add into a local .yml file
      ^^^ notify the user about this
      and then when doing:
      rbt htop
      opne "htop can not be installed because it is pinned down."
      opne to unpin do:
      rbt unpin htop
      rbt --unpin htop
      when pinning, also store the version
      so that in the future we may pin only certain versions
      also add a
      --forbid-installation-of
      ^^^ and document all of this.
--------------------------------------------------------------------------------
(193) → Look at strace. Perhaps we can trace the file calls
      in question.
--------------------------------------------------------------------------------
(194) → We should test updating glibc on some computer system - anywhere.
      Possibly for this, we also need a chrooted environment.
      I guess it is best to simply copy /Depot/Chroot/home/Programs/
      onto a usb stick, then transfer it downstairs.
      Ideally for this we should have compiled all new programs already
      as-is.
--------------------------------------------------------------------------------
(195) → Add some way to upload binary packages or so on ftp, named with
      the particular glibc version that was used to compile it. This
      should be some repository where I can host important packages.
      Hmmmmm. We can simply package the app-dir at hand.
--------------------------------------------------------------------------------
(196) → 3) No package 'libmate-menu' found
      ^^^ das sollte einen vorschlag liefern wie man das löst
      also zum beispiel
      "One suggested way to solve the above issue is by doing:
      rbt matemenus
      yup das geht an sich... den fehler oben müssen wir aber noch
      testen so das es einen guten vorschlag gibt.
      Hmm eher doch nicht ... oder an sich schon.
      Zerst einmal über aliases lösen: ok das hier gelöst.
      wir suchen etwas
      Wir müssen das noch ausführen... gibt es ein Programm?
      mate-control-center zeigt diesen fehleran
      ^^^ auch dokumentieren sobald das geht
      mate-control-center
      well this kind of sucks
      I guess the whole problem+error detection has to be written
      anew, since right now it is just horrible.
--------------------------------------------------------------------------------
(197) → 4) add a toolchain into /home/Programs
      hmm:
      /home/Programs/Toolchain
      ^^^ without versioning for now.
      This should be used for bootstrapping a linux system.
--------------------------------------------------------------------------------
(198) → 1) REWRITE RBT FROM THE GET GO !!!!
--------------------------------------------------------------------------------
(199) → 1) Add the possibility to use abbreviations again, but make it optional.
      The user should be able to toggle this behaviour on the commandline.
      Document this as well.
      THEN TRANSFER TO THE OTHER COMPUTER. Huh? What other computer?
      hmmm.
--------------------------------------------------------------------------------
(200) → 3) Creating GoboLinux Recipes
      Enable homepage: setting in cookbooks though
      AND then use it in the gobo recipes too. Should
      check for some more goborecipes ^^^ via homepage.
      gobolinux.tar.xz
      ^^^ also package that up automatically and then
      upload to a FTP site.
      ^^^ work on this and when it works, announce it on the
      gobolinux mailing list as well.
--------------------------------------------------------------------------------
(201) → 3) Rewrite the whole rbt logic... make use of the internal
      hash more frequently rather than a billion ivars. ALSO,
      from the beginning make sure that w... ah well.
--------------------------------------------------------------------------------
(202) → 4) Flexiblere Plugin Architektur?
      Cmake und Scons Support verbessern. Das ganze sollte abstrahiert
      werden so das man beliebige Tools verwenden kann.
      So das man eine konsistente API verwenden kann.
--------------------------------------------------------------------------------
(203) → →
      RBT::Compile: Something went wrong via `cmake`.
      RBT::Compile: Something went wrong via `cmake`.
      ^^^^^^^^ Don't run this twice; and make the reporting better in general.
      ^^^^^^^^ remove this error. Why does it happen twice anyway
      and why is this so unspecific?
      ^^^ guess we have to go through the whole logic and redo it. Grrrrr.
      hmm.
      Perhaps create a new class that does handle this.
      → ONE CLASS TO RULE ALL THE ERRORS.
      class RBT::ProblemsAndErrors
      ^^^ but study first how to do so.
      We should decide what this class must be able to do:
      a) distinguish between PROBLEMs and ERRORS
      b) use the method .detect() on the given line to detect
      which problems exist.
      c) add the possibility to suggest useful solutions to
      the end user.
      d) store findings on the toplevel e.g.
      RBT.problems?
      and
      RBT.errors?
      ^^^ but do not remove the old code for the time
      being - instead add the above ADDITIONALLY.
      also ... add logging support from the beginning,
      and store the time snaptshots for that.
      ^^^ rework the error logic ...
      THE WHOLE ERROR LOGIC .......
--------------------------------------------------------------------------------
(204) → ry gcc ntrad --reuse-old-configure-options
      RBT::Compile: Re-using the old configure option, which was `--prefix=/Programs/Gcc/8.1.0 --enable-languages=c,c++,lto,objc,fortran --enable-shared --disable-static --disable-multilib --target=x86_64-slackware-linux --build=x86_64-slackware-linux --host=x86_64-slackware-linux --disable-libunwind-exceptions --enable-bootstrap --enable-linker-build-id`.
      RBT::Compile: Now entering the directory `/Depot/Temp/rbt/gcc-8.3.0/BUILD_DIRECTORY/`.
      --prefix=/Programs/Gcc/8.3.0/ --enable-languages=c,c++,lto,objc,fortran --enable-shared --disable-static --disable-multilib --target=x86_64-slackware-linux --build=x86_64-slackware-linux --host=x86_64-slackware-linux --disable-libunwind-exceptions --enable-bootstrap --enable-linker-build-id
      Traceback (most recent call last):
      13: from /Programs/Ruby/2.6.1/bin/rbt:13:in `<main>'
      12: from /Programs/Ruby/2.6.1/bin/rbt:13:in `new'
      11: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/commandline/commandline_interface.rb:60:in `initialize'
      10: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/commandline/commandline_interface.rb:60:in `new'
      9: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/initialize.rb:145:in `initialize'
      8: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/run.rb:23:in `run'
      7: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/menu.rb:34:in `menu'
      6: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/menu.rb:34:in `each'
      5: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/menu.rb:34:in `block in menu'
      4: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/menu.rb:430:in `menu'
      3: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/misc.rb:988:in `reuse_old_configure_options'
      2: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/misc.rb:934:in `run_configure_make_and_make_install_with_this_configure_line'
      1: from /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/configure.rb:53:in `run_the_configure_command'
      /Programs/Ruby/2.6.1/lib/ruby/site_ruby/2.6.0/rbt/compile/prefix.rb:247:
      in `prefix?': undefined method `end_with?' for :use_ntrad_prefix_at_a_later_time:Symbol (NoMethodError)
      ^^^^ hmmmmmmm,mmmmmmm
--------------------------------------------------------------------------------
(205) → ntrad glib --use-this-version=glib-2.54.3.tar.xz
      RBT::Compile: Setting to the specific version `2.54.3` now.
      RBT::Compile: The program `glib` will be compiled/installed next.
      = Infobox ======================================================================
      |                               |                                              |
      | Compiling this program:       | glib                                         |
      | Prefix:                       | /Programs/Glib/2.54.3/                       |
      | Program version:              | 2.54.3                                       |
      | Program path:                 | /Users/x/SRC/glib/glib-2.54.3.tar.xz         |
      | Keep the archive extracted:   | Yes.                                         |
      | Will be extracted towards:    | /Depot/Temp/rbt/glib-2.54.3/                 |
      | Will ccache be used:          | Yes.                                         |
      | CFLAGS in use:                | -O2 -fPIC -fno-strict-overflow -Wno-error    |
      | Use a build directory:        | Yes.                                         |
      | configure options:            | -Dman=true -Dselinux=false                   |
      | Host architecture in use:     | x86_64                                       |
      |                               |                                              |
      ================================================================================
      qdbus: symbol lookup error: /Programs/Qt/5.11.2/bin/../lib/libQt5Core.so.5: undefined symbol: ucnv_getDefaultName_56
      RBT→ Extracter: Extracting `glib-2.54.3.tar.xz` to /Depot/Temp/rbt/ next.
      RBT→ Extracter:   tar -xvf /Users/x/SRC/glib/glib-2.54.3.tar.xz -C /Depot/Temp/rbt/
      RBT→ Extracter: Finished extracting to `/Depot/Temp/rbt/glib-2.54.3/`.
      RBT::Compile: Entering the directory /Depot/Temp/rbt/glib-/Programs/Glib/2.54.3/
      RBT::Compile: Now entering the directory `/Depot/Temp/rbt/glib-/Programs/Glib/2.54.3//BUILD_DIRECTORY/`.
      RBT::CreateProgram: Glib-2.54.3 (Program name: Glib and Program Version: 2.54.3)
      RBT::CreateProgram: The target directory will be at `/Programs/Glib/2.54.3/`.
      RBT::CreateProgram: Creating directory /Programs/Glib/2.54.3/ next.
      RBT::CreateProgram: Several subdirectories will now be created in that directory, namely:
      RBT::CreateProgram:   bin/, include/, lib/, man/, sbin/, Shared/, Resources/
      RBT::CreateProgram: Done!
      RBT→ Symlink: Symlinking /Programs/Glib/2.54.3/ into /Programs/Glib/Current.
      ================================================================================
      CC="ccache gcc" /Depot/Temp/rbt/glib-/Programs/Glib/2.54.3/configure --prefix=/Programs/Glib/2.54.3/ -Dman=true -Dselinux=false 2>&1
      ================================================================================
      sh: /Depot/Temp/rbt/glib-/Programs/Glib/2.54.3/configure: No such file or directory
      Now running `make` from /Depot/Temp/rbt/glib-/Programs/Glib/2.54.3/BUILD_DIRECTORY/.
      make: *** No targets specified and no makefile found.  Stop.
      RBT::Compile: The program `glib` could not be installed.
      ^^^ da stimmt was nit beim verzeichnis... das wo das extracted wird
--------------------------------------------------------------------------------
(206) → sh: meson: command not found
      ^^^
      RBT::Compile: The program `appstream` will be compiled/installed next.
      = Infobox ========================================================================
      |                               |                                                |
      | Compiling this program:       | AppStream                                      |
      | Prefix:                       | /usr/                                          |
      | Program version:              | 0.12.0                                         |
      | Program path:                 | /Users/x/SRC/appstream/AppStream-0.12.0.tar.xz |
      | Keep the archive extracted:   | Yes.                                           |
      | Will be extracted towards:    | /Depot/Temp/rbt/AppStream-0.12.0/              |
      | Will ccache be used:          | Yes.                                           |
      | CFLAGS in use:                | -O2 -fPIC -fno-strict-overflow -Wno-error      |
      | Use a build directory:        | Yes.                                           |
      | Host architecture in use:     | x86_64                                         |
      |                               |                                                |
      ==================================================================================
      RBT→ Extracter: Extracting `AppStream-0.12.0.tar.xz` to /Depot/Temp/rbt/ next.
      RBT→ Extracter:   tar -xvf /Users/x/SRC/appstream/AppStream-0.12.0.tar.xz -C /Depot/Temp/rbt/
      RBT→ Extracter: Finished extracting to `/Depot/Temp/rbt/AppStream-0.12.0/`.
      RBT::Compile: Entering the directory /Depot/Temp/rbt/AppStream-0.12.0/
      RBT::Compile: Now entering the directory `/Depot/Temp/rbt/AppStream-0.12.0/BUILD_DIRECTORY/`.
      meson --prefix=/usr/
      sh: meson: command not found
      RBT::Compile: No file called build.ninja could be found - thus,
      RBT::Compile: the build tool called ninja can not be run.
      Unregistered error: could_not_find_file_called_build_ninja (class: Symbol)
      RBT::Compile: The program `appstream` could not be installed.
      ^^^^ reigster this too to
      switch python
      if is on roebe and
      /Programs/Python/ exists with at the least
      one python version
--------------------------------------------------------------------------------
(207) → See any operating system documentation about shared libraries for
      more information, such as the ldand ld.so(8) manual pages.
--------------------------------------------------------------------------------
(208) → /usr/bin/mkdir -p '/usr/share/gir-1.0/'
      /usr/bin/ginstall -c -m 644 Thunarx-3.0.gir '/usr/share/gir-1.0/'
      /usr/bin/mkdir -p '/usr/include/thunarx-3/thunarx'
      /usr/bin/ginstall -c -m 644 thunarx.h thunarx-config.h thunarx-file-info.h thunarx-menu.h thunarx-menu-item.h thunarx-menu-provider.h thunarx-preferences-provider.h thunarx-property-page.h thunarx-property-page-provider.h thunarx-provider-factory.h thunarx-provider-module.h thunarx-provider-plugin.h thunarx-renamer.h thunarx-renamer-provider.h '/usr/include/thunarx-3/thunarx'
      /usr/bin/mkdir -p '/usr/lib/pkgconfig'
      /usr/bin/ginstall -c -m 644 thunarx-3.pc '/usr/lib/pkgconfig'
      /usr/bin/mkdir -p '/usr/lib/girepository-1.0/'
      /usr/bin/ginstall -c -m 644 Thunarx-3.0.typelib '/usr/lib/girepository-1.0/'
      make[2]: Leaving directory '/Depot/Temp/rbt/Thunar-1.8.1/thunarx'
      make[1]: Leaving directory '/Depot/Temp/rbt/Thunar-1.8.1/thunarx'
      Making install in thunar
      make[1]: Entering directory '/Depot/Temp/rbt/Thunar-1.8.1/thunar'
      make  install-am
      make[2]: Entering directory '/Depot/Temp/rbt/Thunar-1.8.1/thunar'
      CCLD     thunar
      libtool:   error: cannot find the library '/usr/lib64/libudev.la' or unhandled argument '/usr/lib64/libudev.la'
      make[2]: *** [Makefile:910: thunar] Error 1
      make[2]: Leaving directory '/Depot/Temp/rbt/Thunar-1.8.1/thunar'
      make[1]: *** [Makefile:2473: install] Error 2
      make[1]: Leaving directory '/Depot/Temp/rbt/Thunar-1.8.1/thunar'^
      ^^^ autofix?
--------------------------------------------------------------------------------
(209) → installation_steps:
      - make
      - make install DESTDIR=$MY_PROGRAMS/Ncompress/PROGRAM_VERSION
      ^^^^ installation steps seems
      to be bugged
      debug this
      ncompress has that problem right now
--------------------------------------------------------------------------------
(210) → add:
      pre_make_install:
      or something like that...
      for isoode
--------------------------------------------------------------------------------
(211) → /Programs/Gtksourceview/Current/share/gir-1.0//usr/share/gir-1.0
      bash: /usr/share/gir-1.0: Is a directory
      /Programs/Gtksourceview/Current/share/gir-1.0/cp GtkSource-3.0.gir  /usr/share/gir-1.0
      'GtkSource-3.0.gir' - '/usr/share/gir-1.0/GtkSource-3.0.gir'
      ^^^^ the file exists but it has to be symlinked...
--------------------------------------------------------------------------------
(212) → Add a way to parse dependencies of a given program automatically.
      Right now I have absolutely no idea how to do this though. If
      you have an idea, let me know. IF this parsing of dependencies
      is possible, then we will gather this information inside
      DependencyCollector.rb
      The configure.ac file will have stuff such as:
      if $PKG_CONFIG --exists $PANGO_PACKAGES ; then
      We also have checks such as:
      AC_MSG_ERROR([
      *** Accessibility Toolkit not found. Accessibility Toolkit is required
      *** to build GTK+.
      ])
--------------------------------------------------------------------------------
(213) → convert to non-traditional
      must be rewritten. it makes no longer sense.
--------------------------------------------------------------------------------
(214) → add an interactive compile-shell
      the idea here is to continually run that compile-shell and keep
      on compiling and installing stuff, constantly showing to the
      user the current status e. g. what is installed, what can be
      upgraded and what not. the idea here is to completely finish
      all tasks from within that interactive compile shell.
--------------------------------------------------------------------------------
(215) → rbt config?
      RBT::Action::Installer: We will show the configuration options set for the RBT project next.
      /usr/lib/ruby/site_ruby/3.3.0/rbt/actions/individual_actions/installer/installer.rb:11665:in
      `block in feedback_main_config': undefined method `_' for an instance of RBT::Configuration::SimpleConfigurationLoader (NoMethodError)
      hash = RBT.configuration?._ # Delegate to the config.
      ^^
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/lean_prototype/lean_prototype.rb:1105:in `block in cliner'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/toplevel_methods/cliner.rb:63:in `cliner'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/lean_prototype/lean_prototype.rb:1105:in `cliner'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/actions/individual_actions/installer/installer.rb:11664:in `feedback_main_config'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/actions/individual_actions/installer/menu.rb:7941:in `menu'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/actions/individual_actions/installer/menu.rb:22:in `block in menu'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/actions/individual_actions/installer/menu.rb:22:in `each'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/actions/individual_actions/installer/menu.rb:22:in `menu'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/actions/individual_actions/installer/misc.rb:190:in `run'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/actions/individual_actions/installer/installer.rb:285:in `initialize'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/actions/individual_actions/installer/installer.rb:19743:in `new'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/actions/individual_actions/installer/installer.rb:19743:in `installer'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/actions/actions.rb:598:in `action'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/lean_prototype/lean_prototype.rb:3381:in `action'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/commandline/commandline.rb:274:in `do_compile_these_programs'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/commandline/commandline.rb:260:in `run'
      from /usr/lib/ruby/site_ruby/3.3.0/rbt/commandline/commandline.rb:46:in `initialize'
      from /usr/bin/rbt:22:in `new'
      from /usr/bin/rbt:22:in `<main>'
      ^^^ warum geht das nit mehr
--------------------------------------------------------------------------------
