#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# This small .rb file only tests two methods:
#
#   - The first one to query the expanded cookbook dataset.
#
#   - The second one to test whether the SQLITE dataset contains the
#     same result.
# =========================================================================== #
alias e puts

require 'rbt/toplevel_methods/fast_return_file_size_of_this_program.rb'

result1 = RBT.fast_return_file_size_of_this_program(:php) # => 11787892
result2 = RBT.fast_return_file_size_of_this_program(:php, :use_sqlite)

e result1
e result2

e (result1 == result2)