An overview about these scripts is detailed in this file here:

Until the year 2005, more specifically about 26.09.2005, I tried
to write a good ruby script that would allow me to compile and
install programs from sources. I was using GoboLinux back then
and I loved GoboLinux's filesystem - it made sense. But the
shell scripts confused me; I still find shell scripts very
complicated to read and understand.

At any rate: in regards to using that ruby script for some months,
everything went quite fine, until I tried to obtain information
from a yaml file.

At that point, things went the wrong way with that old ruby
script that I used back then:

  - The script essentially became way too large and chaotic,
    with many internal weaknesses and, overall, a true spaghetti
    code layout.

    In short: it collapsed onto its own complexity. It was a
    mess. It fell on its nose. It was not well-designed AT ALL,
    in part due to my inexperience at maintaining code over
    the years.

I then reviewed the initial concept and started to work with a single
yaml file instead, containing all different programs together.
Additionally, I used more, smaller classes - this time almost
everything worked at once.

Lateron, a primitive concept of "Code_Insertions" was added,
where particular behaviour could be modified globally, also
via yaml files. Think of Gentoo's CFLAGs.

The distant goal was to create some kind of "meta distribution" or
base system for a distribution, which could be used as a "build
the desired distribution" - similar to the T2 system.

The RBT project still has this as kind of one of its goals - to
be used, in principle, as the base for some dependent projects,
such as in a Linux distribution or a LFS/BLFS setup ("Linux
from Scratch").

At a later time, aliases were added to the project, including
abbreviations.

For example, "ph" could be used as an alias towards "php5", "ru"
could be used as alias to "ruby" and so forth.

Another feature that was added at a later time was to omit "--" 
for many instructions. For example "--ntrad" could be used as
"ntrad" instead. This simplified using the project from the
commandline - I am truly damn lazy. Or, efficient, depending
on how you want to view it.

At an even later time came support for different build-systems,
such as scons, waf, cmake, meson/ninja and so forth. Support
for the clang compiler was also enabled eventually, even
though RBT still defaults to GCC as the primary compiler.

In February 2024 the whole RBT project was rewritten via an
action-centric approach. Now all meaningful activities of
the RBT project can be split up into different "action
components".

As things changed, the file here became less important for 
tracking or detailing the project, so it will not be updated
that often anymore. Please refer to the homepage of this gem
and the extensive documentation for a larger overview of the
RBT project, including its more recent history.
